#pragma once
#include "taihe/object.hpp"
#include "async.IStringHolder.proj.0.hpp"
#include "async.IStringHolder.abi.1.h"
#include "taihe/string.hpp"
namespace async::weak {
struct IStringHolder {
    static constexpr bool is_holder = false;
    struct async_IStringHolder_t m_handle;
    explicit IStringHolder(struct async_IStringHolder_t handle) : m_handle(handle) {}
    explicit IStringHolder(::taihe::data_view other)
        : IStringHolder(async_IStringHolder_dynamic(other.data_ptr)) {}
    operator ::taihe::data_view() const& {
        struct async_IStringHolder_t ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct async_IStringHolder_t ret_handle = async_IStringHolder_copy(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    struct virtual_type {
        ::taihe::string get() const&;
        void set(::taihe::string_view a) const&;
    };
    template<typename Impl>
    struct methods_impl {
        static struct TString get(struct async_IStringHolder_t tobj);
        static void set(struct async_IStringHolder_t tobj, struct TString a);
    };
    template<typename Impl>
    static constexpr async_IStringHolder_ftable ftbl_impl = {
        .get = &methods_impl<Impl>::get,
        .set = &methods_impl<Impl>::set,
    };
    template<typename Impl>
    static constexpr async_IStringHolder_vtable vtbl_impl = {
        .ftbl_ptr_0 = &::async::weak::IStringHolder::template ftbl_impl<Impl>,
    };
    template<typename Impl>
    static constexpr IdMapItem idmap_impl[1] = {
        {&async_IStringHolder_i, &vtbl_impl<Impl>.ftbl_ptr_0},
    };
    static constexpr void const* iid = &async_IStringHolder_i;
    using vtable_t = async_IStringHolder_vtable;
    explicit operator bool() const& { return m_handle.vtbl_ptr; }
    virtual_type const& operator*() const& {
        return *reinterpret_cast<virtual_type const*>(&m_handle);
    }
    virtual_type const* operator->() const& {
        return reinterpret_cast<virtual_type const*>(&m_handle);
    }
};
}
namespace async {
struct IStringHolder : public ::async::weak::IStringHolder {
    static constexpr bool is_holder = true;
    explicit IStringHolder(struct async_IStringHolder_t handle) : ::async::weak::IStringHolder(handle) {}
    IStringHolder& operator=(::async::IStringHolder other) {
        ::std::swap(m_handle, other.m_handle);
        return *this;
    }
    ~IStringHolder() {
        async_IStringHolder_drop(m_handle);
    }
    explicit IStringHolder(::taihe::data_holder other)
        : IStringHolder(async_IStringHolder_dynamic(other.data_ptr)) {
        other.data_ptr = nullptr;
    }
    operator ::taihe::data_view() const& {
        struct async_IStringHolder_t ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct async_IStringHolder_t ret_handle = async_IStringHolder_copy(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() && {
        struct async_IStringHolder_t ret_handle = m_handle;
        m_handle.data_ptr = nullptr;
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    IStringHolder(::async::weak::IStringHolder const& other)
        : IStringHolder(async_IStringHolder_copy(other.m_handle)) {}
    IStringHolder(::async::IStringHolder const& other)
        : IStringHolder(async_IStringHolder_copy(other.m_handle)) {}
    IStringHolder(::async::IStringHolder&& other)
        : IStringHolder(other.m_handle) {
        other.m_handle.data_ptr = nullptr;
    }
};
}
namespace taihe {
template<>
struct as_abi<::async::IStringHolder> {
    using type = struct async_IStringHolder_t;
};
template<>
struct as_abi<::async::weak::IStringHolder> {
    using type = struct async_IStringHolder_t;
};
template<>
struct as_param<::async::IStringHolder> {
    using type = ::async::weak::IStringHolder;
};
}
