#include "async.proj.hpp"
#include "async.impl.hpp"
#include "taihe/runtime.hpp"
#include "stdexcept"

using namespace taihe;
using namespace async;

namespace {
// To be implemented.

class IStringHolderImpl {
public:
    IStringHolderImpl() {
        // Don't forget to implement the constructor.
    }

    string get() {
        TH_THROW(std::runtime_error, "get not implemented");
    }

    void set(string_view a) {
        TH_THROW(std::runtime_error, "set not implemented");
    }
};

int32_t addSync(int32_t a, int32_t b) {
    TH_THROW(std::runtime_error, "addSync not implemented");
}

IStringHolder makeIStringHolder() {
    // The parameters in the make_holder function should be of the same type
    // as the parameters in the constructor of the actual implementation class.
    return make_holder<IStringHolderImpl, IStringHolder>();
}
}  // namespace

TH_EXPORT_CPP_API_addSync(addSync);
TH_EXPORT_CPP_API_makeIStringHolder(makeIStringHolder);
