#include "bigint_test.ani.hpp"
#include "bigint_test.user.hpp"
static ani_long bigint_test_getNumfromBigint_ANIFunc0([[maybe_unused]] ani_env *env, ani_array_long ani_arg_a) {
    ::taihe::set_env(env);
    size_t cpp_arg_a_size;
    env->Array_GetLength(ani_arg_a, &cpp_arg_a_size);
    int64_t* cpp_arg_a_buffer = (int64_t*)malloc(cpp_arg_a_size * sizeof(int64_t));
    env->Array_GetRegion_Long(ani_arg_a, 0, cpp_arg_a_size, reinterpret_cast<ani_long*>(cpp_arg_a_buffer));
    ::taihe::array<int64_t> cpp_arg_a(cpp_arg_a_buffer, cpp_arg_a_size);
    int64_t cpp_result = ::bigint_test::getNumfromBigint(cpp_arg_a);
    if (::taihe::has_error()) { return ani_long{}; }
    ani_long ani_result = (int64_t)cpp_result;
    return ani_result;
}
static ani_array_long bigint_test_genBigint_ANIFunc0([[maybe_unused]] ani_env *env, ani_array_long ani_arg_a) {
    ::taihe::set_env(env);
    size_t cpp_arg_a_size;
    env->Array_GetLength(ani_arg_a, &cpp_arg_a_size);
    int64_t* cpp_arg_a_buffer = (int64_t*)malloc(cpp_arg_a_size * sizeof(int64_t));
    env->Array_GetRegion_Long(ani_arg_a, 0, cpp_arg_a_size, reinterpret_cast<ani_long*>(cpp_arg_a_buffer));
    ::taihe::array<int64_t> cpp_arg_a(cpp_arg_a_buffer, cpp_arg_a_size);
    ::taihe::array<int64_t> cpp_result = ::bigint_test::genBigint(cpp_arg_a);
    if (::taihe::has_error()) { return ani_array_long{}; }
    size_t ani_result_size = cpp_result.size();
    ani_array_long ani_result;
    env->Array_New_Long(ani_result_size, &ani_result);
    env->Array_SetRegion_Long(ani_result, 0, ani_result_size, reinterpret_cast<ani_long const*>(cpp_result.data()));
    return ani_result;
}
namespace bigint_test {
ani_status ANIRegister(ani_env *env) {
    {
        ani_module ani_env;
        if (ANI_OK != env->FindModule("Lbigint_test;", &ani_env)) {
            return ANI_ERROR;
        }
        ani_native_function methods[] = {
            {"getNumfromBigint_inner", nullptr, reinterpret_cast<void*>(bigint_test_getNumfromBigint_ANIFunc0)},

            {"genBigint_inner", nullptr, reinterpret_cast<void*>(bigint_test_genBigint_ANIFunc0)},

        };
        if (ANI_OK != env->Module_BindNativeFunctions(ani_env, methods, sizeof(methods) / sizeof(ani_native_function))) {
            return ANI_ERROR;
        }
    }
    return ANI_OK;
}
}
