#pragma once
#include "taihe/common.hpp"
#include "binding.Color.proj.0.hpp"
#include "binding.Color.abi.1.h"
namespace binding {
struct Color {
    int32_t R;
    int32_t G;
    int32_t B;
};
}
namespace taihe {
inline auto hash_impl(adl_helper_t, ::binding::Color const& val) -> ::std::size_t {
    ::std::size_t seed = 0;
    seed ^= hash(val.R) + 0x9e3779b9 + (seed << 6) + (seed >> 2);
    seed ^= hash(val.G) + 0x9e3779b9 + (seed << 6) + (seed >> 2);
    seed ^= hash(val.B) + 0x9e3779b9 + (seed << 6) + (seed >> 2);
    return seed;
}
}
namespace taihe {
inline bool same_impl(adl_helper_t, ::binding::Color const& lhs, ::binding::Color const& rhs) {
    return true && same(lhs.R, rhs.R) && same(lhs.G, rhs.G) && same(lhs.B, rhs.B);
}
}
namespace taihe {
template<>
struct as_abi<::binding::Color> {
    using type = struct binding_Color_t;
};
template<>
struct as_abi<::binding::Color const&> {
    using type = struct binding_Color_t const*;
};
template<>
struct as_param<::binding::Color> {
    using type = ::binding::Color const&;
};
}
