#pragma once
#include "callback.Person.ani.0.h"
#include "callback.Person.proj.1.hpp"
inline ::callback::Person callback_Person_fromANI(ani_env* env, ani_object ani_obj) {
    ani_string ani_field_name;
    env->Object_GetPropertyByName_Ref(ani_obj, "name", reinterpret_cast<ani_ref*>(&ani_field_name));

    ani_size cpp_field_name_len;
    env->String_GetUTF8Size(ani_field_name, &cpp_field_name_len);
    TString cpp_field_name_tstr;
    char* cpp_field_name_buf = tstr_initialize(&cpp_field_name_tstr, cpp_field_name_len + 1);
    env->String_GetUTF8(ani_field_name, cpp_field_name_buf, cpp_field_name_len + 1, &cpp_field_name_len);
    cpp_field_name_buf[cpp_field_name_len] = '\0';
    cpp_field_name_tstr.length = cpp_field_name_len;
    taihe::string cpp_field_name = taihe::string(cpp_field_name_tstr);
    ani_int ani_field_age;
    env->Object_GetPropertyByName_Int(ani_obj, "age", reinterpret_cast<ani_int*>(&ani_field_age));

    int32_t cpp_field_age = (int32_t)ani_field_age;
    return ::callback::Person{std::move(cpp_field_name), std::move(cpp_field_age)};
}
inline ani_object callback_Person_intoANI(ani_env* env, ::callback::Person const& cpp_obj) {
    ani_string ani_field_name;
    env->String_NewUTF8(cpp_obj.name.c_str(), cpp_obj.name.size(), &ani_field_name);
    ani_int ani_field_age = (int32_t)cpp_obj.age;
    ani_class ani_obj_cls;
    env->FindClass("Lcallback/Person_inner;", &ani_obj_cls);
    ani_method ani_obj_ctor;
    env->Class_FindMethod(ani_obj_cls, "<ctor>", nullptr, &ani_obj_ctor);
    ani_object ani_obj;
    env->Object_New(ani_obj_cls, ani_obj_ctor, &ani_obj, ani_field_name, ani_field_age);
    return ani_obj;
}
