#include "callback.proj.hpp"
#include "callback.impl.hpp"
#include "taihe/runtime.hpp"
#include "stdexcept"

using namespace taihe;
using namespace callback;

namespace {
// To be implemented.

void cb_void_void(callback_view<void()> f) {
    TH_THROW(std::runtime_error, "cb_void_void not implemented");
}

void cb_i_void(callback_view<void(int32_t)> f) {
    TH_THROW(std::runtime_error, "cb_i_void not implemented");
}

string cb_str_str(callback_view<string(string_view)> f) {
    TH_THROW(std::runtime_error, "cb_str_str not implemented");
}

void cb_struct(callback_view<Person(Person const&)> f) {
    TH_THROW(std::runtime_error, "cb_struct not implemented");
}
}  // namespace

TH_EXPORT_CPP_API_cb_void_void(cb_void_void);
TH_EXPORT_CPP_API_cb_i_void(cb_i_void);
TH_EXPORT_CPP_API_cb_str_str(cb_str_str);
TH_EXPORT_CPP_API_cb_struct(cb_struct);
