#pragma once
#include "taihe/common.hpp"
#include "ohos.book.store.Book.proj.0.hpp"
#include "ohos.book.store.Book.abi.1.h"
#include "taihe/string.hpp"
#include "ohos.book.store.Category.proj.0.hpp"
namespace ohos::book::store {
struct Book {
    ::taihe::string title;
    int32_t year;
    ::ohos::book::store::Category category;
};
}
namespace taihe {
inline auto hash_impl(adl_helper_t, ::ohos::book::store::Book const& val) -> ::std::size_t {
    ::std::size_t seed = 0;
    seed ^= hash(val.title) + 0x9e3779b9 + (seed << 6) + (seed >> 2);
    seed ^= hash(val.year) + 0x9e3779b9 + (seed << 6) + (seed >> 2);
    seed ^= hash(val.category) + 0x9e3779b9 + (seed << 6) + (seed >> 2);
    return seed;
}
}
namespace taihe {
inline bool same_impl(adl_helper_t, ::ohos::book::store::Book const& lhs, ::ohos::book::store::Book const& rhs) {
    return true && same(lhs.title, rhs.title) && same(lhs.year, rhs.year) && same(lhs.category, rhs.category);
}
}
namespace taihe {
template<>
struct as_abi<::ohos::book::store::Book> {
    using type = struct ohos_book_store_Book_t;
};
template<>
struct as_abi<::ohos::book::store::Book const&> {
    using type = struct ohos_book_store_Book_t const*;
};
template<>
struct as_param<::ohos::book::store::Book> {
    using type = ::ohos::book::store::Book const&;
};
}
