#pragma once
#include "taihe/object.hpp"
#include "ohos.book.store.Bookstore.proj.0.hpp"
#include "ohos.book.store.Bookstore.abi.1.h"
#include "ohos.book.store.Book.proj.0.hpp"
namespace ohos::book::store::weak {
struct Bookstore {
    static constexpr bool is_holder = false;
    struct ohos_book_store_Bookstore_t m_handle;
    explicit Bookstore(struct ohos_book_store_Bookstore_t handle) : m_handle(handle) {}
    explicit Bookstore(::taihe::data_view other)
        : Bookstore(ohos_book_store_Bookstore_dynamic(other.data_ptr)) {}
    operator ::taihe::data_view() const& {
        struct ohos_book_store_Bookstore_t ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct ohos_book_store_Bookstore_t ret_handle = ohos_book_store_Bookstore_copy(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    struct virtual_type {
        void addBook(::ohos::book::store::Book const& book, double price, int32_t count) const&;
        void saleBook(::ohos::book::store::Book const& book) const&;
        double getDiscount() const&;
        void setDiscount(double percent) const&;
        double getTotalSales() const&;
    };
    template<typename Impl>
    struct methods_impl {
        static void addBook(struct ohos_book_store_Bookstore_t tobj, struct ohos_book_store_Book_t const* book, double price, int32_t count);
        static void saleBook(struct ohos_book_store_Bookstore_t tobj, struct ohos_book_store_Book_t const* book);
        static double getDiscount(struct ohos_book_store_Bookstore_t tobj);
        static void setDiscount(struct ohos_book_store_Bookstore_t tobj, double percent);
        static double getTotalSales(struct ohos_book_store_Bookstore_t tobj);
    };
    template<typename Impl>
    static constexpr ohos_book_store_Bookstore_ftable ftbl_impl = {
        .addBook = &methods_impl<Impl>::addBook,
        .saleBook = &methods_impl<Impl>::saleBook,
        .getDiscount = &methods_impl<Impl>::getDiscount,
        .setDiscount = &methods_impl<Impl>::setDiscount,
        .getTotalSales = &methods_impl<Impl>::getTotalSales,
    };
    template<typename Impl>
    static constexpr ohos_book_store_Bookstore_vtable vtbl_impl = {
        .ftbl_ptr_0 = &::ohos::book::store::weak::Bookstore::template ftbl_impl<Impl>,
    };
    template<typename Impl>
    static constexpr IdMapItem idmap_impl[1] = {
        {&ohos_book_store_Bookstore_i, &vtbl_impl<Impl>.ftbl_ptr_0},
    };
    static constexpr void const* iid = &ohos_book_store_Bookstore_i;
    using vtable_t = ohos_book_store_Bookstore_vtable;
    explicit operator bool() const& { return m_handle.vtbl_ptr; }
    virtual_type const& operator*() const& {
        return *reinterpret_cast<virtual_type const*>(&m_handle);
    }
    virtual_type const* operator->() const& {
        return reinterpret_cast<virtual_type const*>(&m_handle);
    }
};
}
namespace ohos::book::store {
struct Bookstore : public ::ohos::book::store::weak::Bookstore {
    static constexpr bool is_holder = true;
    explicit Bookstore(struct ohos_book_store_Bookstore_t handle) : ::ohos::book::store::weak::Bookstore(handle) {}
    Bookstore& operator=(::ohos::book::store::Bookstore other) {
        ::std::swap(m_handle, other.m_handle);
        return *this;
    }
    ~Bookstore() {
        ohos_book_store_Bookstore_drop(m_handle);
    }
    explicit Bookstore(::taihe::data_holder other)
        : Bookstore(ohos_book_store_Bookstore_dynamic(other.data_ptr)) {
        other.data_ptr = nullptr;
    }
    operator ::taihe::data_view() const& {
        struct ohos_book_store_Bookstore_t ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct ohos_book_store_Bookstore_t ret_handle = ohos_book_store_Bookstore_copy(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() && {
        struct ohos_book_store_Bookstore_t ret_handle = m_handle;
        m_handle.data_ptr = nullptr;
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    Bookstore(::ohos::book::store::weak::Bookstore const& other)
        : Bookstore(ohos_book_store_Bookstore_copy(other.m_handle)) {}
    Bookstore(::ohos::book::store::Bookstore const& other)
        : Bookstore(ohos_book_store_Bookstore_copy(other.m_handle)) {}
    Bookstore(::ohos::book::store::Bookstore&& other)
        : Bookstore(other.m_handle) {
        other.m_handle.data_ptr = nullptr;
    }
};
}
namespace taihe {
template<>
struct as_abi<::ohos::book::store::Bookstore> {
    using type = struct ohos_book_store_Bookstore_t;
};
template<>
struct as_abi<::ohos::book::store::weak::Bookstore> {
    using type = struct ohos_book_store_Bookstore_t;
};
template<>
struct as_param<::ohos::book::store::Bookstore> {
    using type = ::ohos::book::store::weak::Bookstore;
};
}
