#pragma once
#include "taihe/common.hpp"
namespace ohos::book::store {
struct Category {
    enum class key_t: int {
        CPP,
        RUST,
    };
    Category(key_t key) : key(key) {}
    Category(Category const& other) : key(other.key) {}
    Category& operator=(Category other) {
        key = other.key;
        return *this;
    }
    key_t get_key() const {
        return this->key;
    }
    static constexpr char const* table[] = {
        "C++",
        "Rust",
    };
    char const* get_value() const {
        return table[(int)key];
    }
    operator char const*() const {
        return table[(int)key];
    }
private:
    key_t key;
};
}
namespace taihe {
inline bool same_impl(adl_helper_t, ::ohos::book::store::Category lhs, ::ohos::book::store::Category rhs) {
    return lhs.get_key() == rhs.get_key();
}
}
namespace taihe {
inline auto hash_impl(adl_helper_t, ::ohos::book::store::Category val) -> ::std::size_t {
    return ::std::hash<int>{}((int)val.get_key());
}
}
namespace taihe {
template<>
struct as_abi<::ohos::book::store::Category> {
    using type = int;
};
template<>
struct as_param<::ohos::book::store::Category> {
    using type = ::ohos::book::store::Category;
};
}
