#pragma once
#include "taihe/common.hpp"
#include "ohos.book.store.abi.h"
#include "taihe/string.hpp"
#include "ohos.book.store.Category.proj.0.hpp"
#include "ohos.book.store.Book.proj.1.hpp"
#include "ohos.book.store.MapOption.proj.1.hpp"
#include "taihe/map.hpp"
#include "taihe/array.hpp"
#include "taihe/optional.hpp"
#include "taihe/callback.hpp"
#include "ohos.book.store.Bookstore.proj.2.hpp"
#include "ohos.book.store.CppOrRustBook.proj.1.hpp"
#include "ohos.book.store.FancyBook.proj.2.hpp"
#include "ohos.book.store.Path.proj.2.hpp"
#define TH_EXPORT_CPP_API_ConstructBook(CPP_FUNC_IMPL) \
    struct ohos_book_store_Book_t ohos_book_store_ConstructBook_f(struct TString title, int32_t year, int kind) { \
        return ::taihe::into_abi<::ohos::book::store::Book>(CPP_FUNC_IMPL(::taihe::from_abi<::taihe::string_view>(title), ::taihe::from_abi<int32_t>(year), ::taihe::from_abi<::ohos::book::store::Category>(kind))); \
    }
#define TH_EXPORT_CPP_API_PrintBook(CPP_FUNC_IMPL) \
    void ohos_book_store_PrintBook_f(struct ohos_book_store_Book_t const* b) { \
        return CPP_FUNC_IMPL(::taihe::from_abi<::ohos::book::store::Book const&>(b)); \
    }
#define TH_EXPORT_CPP_API_MapBookToYear(CPP_FUNC_IMPL) \
    void* ohos_book_store_MapBookToYear_f(struct ohos_book_store_MapOption_t const* opt) { \
        return ::taihe::into_abi<::taihe::map<::taihe::string, int32_t>>(CPP_FUNC_IMPL(::taihe::from_abi<::ohos::book::store::MapOption const&>(opt))); \
    }
#define TH_EXPORT_CPP_API_PrintBooksWithFilter(CPP_FUNC_IMPL) \
    void ohos_book_store_PrintBooksWithFilter_f(struct TArray books, struct TOptional filter) { \
        return CPP_FUNC_IMPL(::taihe::from_abi<::taihe::array_view<::ohos::book::store::Book>>(books), ::taihe::from_abi<::taihe::optional_view<::taihe::callback<bool(::ohos::book::store::Book const&)>>>(filter)); \
    }
#define TH_EXPORT_CPP_API_CreateBookstore(CPP_FUNC_IMPL) \
    struct ohos_book_store_Bookstore_t ohos_book_store_CreateBookstore_f() { \
        return ::taihe::into_abi<::ohos::book::store::Bookstore>(CPP_FUNC_IMPL()); \
    }
#define TH_EXPORT_CPP_API_SayHello(CPP_FUNC_IMPL) \
    void ohos_book_store_SayHello_f() { \
        return CPP_FUNC_IMPL(); \
    }
#define TH_EXPORT_CPP_API_PrintBookAdvanced(CPP_FUNC_IMPL) \
    void ohos_book_store_PrintBookAdvanced_f(struct ohos_book_store_CppOrRustBook_t const* book) { \
        return CPP_FUNC_IMPL(::taihe::from_abi<::ohos::book::store::CppOrRustBook const&>(book)); \
    }
#define TH_EXPORT_CPP_API_MakeFancyBook(CPP_FUNC_IMPL) \
    struct ohos_book_store_FancyBook_t ohos_book_store_MakeFancyBook_f() { \
        return ::taihe::into_abi<::ohos::book::store::FancyBook>(CPP_FUNC_IMPL()); \
    }
#define TH_EXPORT_CPP_API_SaveBookToInternet(CPP_FUNC_IMPL) \
    void ohos_book_store_SaveBookToInternet_f(struct TString url) { \
        return CPP_FUNC_IMPL(::taihe::from_abi<::taihe::string_view>(url)); \
    }
#define TH_EXPORT_CPP_API_SaveBookToFile(CPP_FUNC_IMPL) \
    void ohos_book_store_SaveBookToFile_f(struct ohos_book_store_Path_t p) { \
        return CPP_FUNC_IMPL(::taihe::from_abi<::ohos::book::store::weak::Path>(p)); \
    }
#define TH_EXPORT_CPP_API_uploadBook(CPP_FUNC_IMPL) \
    struct TString ohos_book_store_uploadBook_f(struct ohos_book_store_Book_t const* b) { \
        return ::taihe::into_abi<::taihe::string>(CPP_FUNC_IMPL(::taihe::from_abi<::ohos::book::store::Book const&>(b))); \
    }
#define TH_EXPORT_CPP_API_onBookSold(CPP_FUNC_IMPL) \
    void ohos_book_store_onBookSold_f() { \
        return CPP_FUNC_IMPL(); \
    }
#define TH_EXPORT_CPP_API_onNewBook(CPP_FUNC_IMPL) \
    void ohos_book_store_onNewBook_f() { \
        return CPP_FUNC_IMPL(); \
    }
#define TH_EXPORT_CPP_API_IsString(CPP_FUNC_IMPL) \
    bool ohos_book_store_IsString_f(uintptr_t s) { \
        return ::taihe::into_abi<bool>(CPP_FUNC_IMPL(::taihe::from_abi<uintptr_t>(s))); \
    }
#define TH_EXPORT_CPP_API_GetStringArray(CPP_FUNC_IMPL) \
    struct TArray ohos_book_store_GetStringArray_f() { \
        return ::taihe::into_abi<::taihe::array<uintptr_t>>(CPP_FUNC_IMPL()); \
    }
