#pragma once
#include "ohos.book.store.proj.hpp"
#include "taihe/common.hpp"
#include "ohos.book.store.abi.h"
#include "taihe/string.hpp"
#include "ohos.book.store.Category.proj.0.hpp"
#include "ohos.book.store.Book.proj.1.hpp"
#include "ohos.book.store.MapOption.proj.1.hpp"
#include "taihe/map.hpp"
#include "taihe/array.hpp"
#include "taihe/optional.hpp"
#include "taihe/callback.hpp"
#include "ohos.book.store.Bookstore.proj.2.hpp"
#include "ohos.book.store.CppOrRustBook.proj.1.hpp"
#include "ohos.book.store.FancyBook.proj.2.hpp"
#include "ohos.book.store.Path.proj.2.hpp"
namespace ohos::book::store {
inline ::ohos::book::store::Book ConstructBook(::taihe::string_view title, int32_t year, ::ohos::book::store::Category kind) {
    return ::taihe::from_abi<::ohos::book::store::Book>(ohos_book_store_ConstructBook_f(::taihe::into_abi<::taihe::string_view>(title), ::taihe::into_abi<int32_t>(year), ::taihe::into_abi<::ohos::book::store::Category>(kind)));
}
}
namespace ohos::book::store {
inline void PrintBook(::ohos::book::store::Book const& b) {
    return ohos_book_store_PrintBook_f(::taihe::into_abi<::ohos::book::store::Book const&>(b));
}
}
namespace ohos::book::store {
inline ::taihe::map<::taihe::string, int32_t> MapBookToYear(::ohos::book::store::MapOption const& opt) {
    return ::taihe::from_abi<::taihe::map<::taihe::string, int32_t>>(ohos_book_store_MapBookToYear_f(::taihe::into_abi<::ohos::book::store::MapOption const&>(opt)));
}
}
namespace ohos::book::store {
inline void PrintBooksWithFilter(::taihe::array_view<::ohos::book::store::Book> books, ::taihe::optional_view<::taihe::callback<bool(::ohos::book::store::Book const&)>> filter) {
    return ohos_book_store_PrintBooksWithFilter_f(::taihe::into_abi<::taihe::array_view<::ohos::book::store::Book>>(books), ::taihe::into_abi<::taihe::optional_view<::taihe::callback<bool(::ohos::book::store::Book const&)>>>(filter));
}
}
namespace ohos::book::store {
inline ::ohos::book::store::Bookstore CreateBookstore() {
    return ::taihe::from_abi<::ohos::book::store::Bookstore>(ohos_book_store_CreateBookstore_f());
}
}
namespace ohos::book::store {
inline void SayHello() {
    return ohos_book_store_SayHello_f();
}
}
namespace ohos::book::store {
inline void PrintBookAdvanced(::ohos::book::store::CppOrRustBook const& book) {
    return ohos_book_store_PrintBookAdvanced_f(::taihe::into_abi<::ohos::book::store::CppOrRustBook const&>(book));
}
}
namespace ohos::book::store {
inline ::ohos::book::store::FancyBook MakeFancyBook() {
    return ::taihe::from_abi<::ohos::book::store::FancyBook>(ohos_book_store_MakeFancyBook_f());
}
}
namespace ohos::book::store {
inline void SaveBookToInternet(::taihe::string_view url) {
    return ohos_book_store_SaveBookToInternet_f(::taihe::into_abi<::taihe::string_view>(url));
}
}
namespace ohos::book::store {
inline void SaveBookToFile(::ohos::book::store::weak::Path p) {
    return ohos_book_store_SaveBookToFile_f(::taihe::into_abi<::ohos::book::store::weak::Path>(p));
}
}
namespace ohos::book::store {
inline ::taihe::string uploadBook(::ohos::book::store::Book const& b) {
    return ::taihe::from_abi<::taihe::string>(ohos_book_store_uploadBook_f(::taihe::into_abi<::ohos::book::store::Book const&>(b)));
}
}
namespace ohos::book::store {
inline void onBookSold() {
    return ohos_book_store_onBookSold_f();
}
}
namespace ohos::book::store {
inline void onNewBook() {
    return ohos_book_store_onNewBook_f();
}
}
namespace ohos::book::store {
inline bool IsString(uintptr_t s) {
    return ::taihe::from_abi<bool>(ohos_book_store_IsString_f(::taihe::into_abi<uintptr_t>(s)));
}
}
namespace ohos::book::store {
inline ::taihe::array<uintptr_t> GetStringArray() {
    return ::taihe::from_abi<::taihe::array<uintptr_t>>(ohos_book_store_GetStringArray_f());
}
}
