#include "ohos.book.store.ani.hpp"
#include "ohos.book.store.user.hpp"
#include "ohos.book.store.Book.ani.1.h"
#include "ohos.book.store.MapOption.ani.1.h"
#include "ohos.book.store.Bookstore.ani.1.h"
#include "ohos.book.store.CppOrRustBook.ani.1.h"
#include "ohos.book.store.FancyBook.ani.1.h"
#include "ohos.book.store.Path.ani.1.h"
static ani_object ohos_book_store_ConstructBook_ANIFunc([[maybe_unused]] ani_env *env, ani_string ani_arg_title, ani_int ani_arg_year, ani_enum_item ani_arg_kind) {
    ::taihe::set_env(env);
    ani_size cpp_arg_title_len;
    env->String_GetUTF8Size(ani_arg_title, &cpp_arg_title_len);
    TString cpp_arg_title_tstr;
    char* cpp_arg_title_buf = tstr_initialize(&cpp_arg_title_tstr, cpp_arg_title_len + 1);
    env->String_GetUTF8(ani_arg_title, cpp_arg_title_buf, cpp_arg_title_len + 1, &cpp_arg_title_len);
    cpp_arg_title_buf[cpp_arg_title_len] = '\0';
    cpp_arg_title_tstr.length = cpp_arg_title_len;
    taihe::string cpp_arg_title = taihe::string(cpp_arg_title_tstr);
    int32_t cpp_arg_year = (int32_t)ani_arg_year;
    ani_size cpp_arg_kind_ani;
    env->EnumItem_GetIndex(ani_arg_kind, &cpp_arg_kind_ani);
    ::ohos::book::store::Category cpp_arg_kind((::ohos::book::store::Category::key_t)cpp_arg_kind_ani);
    ::ohos::book::store::Book cpp_result = ::ohos::book::store::ConstructBook(cpp_arg_title, cpp_arg_year, cpp_arg_kind);
    if (::taihe::has_error()) { return ani_object{}; }
    ani_object ani_result = ohos_book_store_Book_intoANI(env, cpp_result);
    return ani_result;
}
static void ohos_book_store_PrintBook_ANIFunc([[maybe_unused]] ani_env *env, ani_object ani_arg_b) {
    ::taihe::set_env(env);
    ::ohos::book::store::Book cpp_arg_b = ohos_book_store_Book_fromANI(env, ani_arg_b);
    ::ohos::book::store::PrintBook(cpp_arg_b);
}
static ani_object ohos_book_store_MapBookToYear_ANIFunc([[maybe_unused]] ani_env *env, ani_ref ani_arg_opt) {
    ::taihe::set_env(env);
    ::ohos::book::store::MapOption cpp_arg_opt = ohos_book_store_MapOption_fromANI(env, ani_arg_opt);
    ::taihe::map<::taihe::string, int32_t> cpp_result = ::ohos::book::store::MapBookToYear(cpp_arg_opt);
    if (::taihe::has_error()) { return ani_object{}; }
    ani_class ani_result_class;
    env->FindClass("Lescompat/Record;", &ani_result_class);
ani_method ani_result_ctor;
    env->Class_FindMethod(ani_result_class, "<ctor>", nullptr, &ani_result_ctor);
ani_object ani_result;
    env->Object_New(ani_result_class, ani_result_ctor, &ani_result);
    for (const auto& [ani_result_cpp_key, ani_result_cpp_val] : cpp_result) {
        ani_string ani_result_ani_key;
        env->String_NewUTF8(ani_result_cpp_key.c_str(), ani_result_cpp_key.size(), &ani_result_ani_key);
        ani_class ani_result_ani_val_cls;
        env->FindClass("Lstd/core/Int;", &ani_result_ani_val_cls);
ani_method ani_result_ani_val_ctor;
        env->Class_FindMethod(ani_result_ani_val_cls, "<ctor>", "I:V", &ani_result_ani_val_ctor);
ani_object ani_result_ani_val;
        ani_int ani_result_ani_val_ani = (int32_t)ani_result_cpp_val;
        env->Object_New(ani_result_ani_val_cls, ani_result_ani_val_ctor, &ani_result_ani_val, ani_result_ani_val_ani);
        env->Object_CallMethodByName_Void(ani_result, "$_set", nullptr, ani_result_ani_key, ani_result_ani_val);
}
    return ani_result;
}
static void ohos_book_store_PrintBooksWithFilter_ANIFunc([[maybe_unused]] ani_env *env, ani_array_ref ani_arg_books, ani_ref ani_arg_filter) {
    ::taihe::set_env(env);
    size_t cpp_arg_books_size;
    env->Array_GetLength(ani_arg_books, &cpp_arg_books_size);
    ::ohos::book::store::Book* cpp_arg_books_buffer = (::ohos::book::store::Book*)malloc(cpp_arg_books_size * sizeof(::ohos::book::store::Book));
    for (size_t cpp_arg_books_buffer_i = 0; cpp_arg_books_buffer_i < cpp_arg_books_size; cpp_arg_books_buffer_i++) {
        ani_object cpp_arg_books_buffer_ani_item;
        env->Array_Get_Ref(ani_arg_books, cpp_arg_books_buffer_i, reinterpret_cast<ani_ref*>(&cpp_arg_books_buffer_ani_item));
        ::ohos::book::store::Book cpp_arg_books_buffer_cpp_item = ohos_book_store_Book_fromANI(env, cpp_arg_books_buffer_ani_item);
        new (&cpp_arg_books_buffer[cpp_arg_books_buffer_i]) ::ohos::book::store::Book(std::move(cpp_arg_books_buffer_cpp_item));
    }
    ::taihe::array<::ohos::book::store::Book> cpp_arg_books(cpp_arg_books_buffer, cpp_arg_books_size);
    ani_boolean cpp_arg_filter_flag;
    ::taihe::callback<bool(::ohos::book::store::Book const&)>* cpp_arg_filter_ptr = nullptr;
    env->Reference_IsUndefined(ani_arg_filter, &cpp_arg_filter_flag);
    if (!cpp_arg_filter_flag) {
        struct cpp_arg_filter_spec_cpp_impl_t {
            ani_env* env;
            ani_object ref;
            cpp_arg_filter_spec_cpp_impl_t(ani_env* env, ani_object obj): env(env) {
                this->env->GlobalReference_Create(obj, reinterpret_cast<ani_ref*>(&this->ref));
            }
            ~cpp_arg_filter_spec_cpp_impl_t() {
                this->env->GlobalReference_Delete(this->ref);
            }
            bool operator()(::ohos::book::store::Book const& cpp_arg_0) {
                ani_object ani_arg_0 = ohos_book_store_Book_intoANI(this->env, cpp_arg_0);
                ani_ref ani_argv[] = {ani_arg_0};
                ani_ref ani_result;
                this->env->FunctionalObject_Call(static_cast<ani_fn_object>(this->ref), 1, ani_argv, &ani_result);
                ani_class cpp_result_cls;
                this->env->FindClass("Lstd/core/Boolean;", &cpp_result_cls);
ani_method cpp_result_get;
                this->env->Class_FindMethod(cpp_result_cls, "unboxed", nullptr, &cpp_result_get);
ani_boolean cpp_result_ani;
                this->env->Object_CallMethod_Boolean((ani_object)ani_result, cpp_result_get, &cpp_result_ani);
                bool cpp_result = (bool)cpp_result_ani;
                return cpp_result;
            }
        };
        ::taihe::callback<bool(::ohos::book::store::Book const&)> cpp_arg_filter_spec = ::taihe::callback<bool(::ohos::book::store::Book const&)>::from<cpp_arg_filter_spec_cpp_impl_t>(env, static_cast<ani_object>(ani_arg_filter));
        cpp_arg_filter_ptr = new ::taihe::callback<bool(::ohos::book::store::Book const&)>(std::move(cpp_arg_filter_spec));
    };
    ::taihe::optional<::taihe::callback<bool(::ohos::book::store::Book const&)>> cpp_arg_filter(cpp_arg_filter_ptr);
    ::ohos::book::store::PrintBooksWithFilter(cpp_arg_books, cpp_arg_filter);
}
static ani_object ohos_book_store_CreateBookstore_ANIFunc([[maybe_unused]] ani_env *env) {
    ::taihe::set_env(env);
    ::ohos::book::store::Bookstore cpp_result = ::ohos::book::store::CreateBookstore();
    if (::taihe::has_error()) { return ani_object{}; }
    ani_object ani_result = ohos_book_store_Bookstore_intoANI(env, cpp_result);
    return ani_result;
}
static void ohos_book_store_SayHello_ANIFunc([[maybe_unused]] ani_env *env) {
    ::taihe::set_env(env);
    ::ohos::book::store::SayHello();
}
static void ohos_book_store_PrintBookAdvanced_ANIFunc([[maybe_unused]] ani_env *env, ani_ref ani_arg_book) {
    ::taihe::set_env(env);
    ::ohos::book::store::CppOrRustBook cpp_arg_book = ohos_book_store_CppOrRustBook_fromANI(env, ani_arg_book);
    ::ohos::book::store::PrintBookAdvanced(cpp_arg_book);
}
static ani_object ohos_book_store_MakeFancyBook_ANIFunc([[maybe_unused]] ani_env *env) {
    ::taihe::set_env(env);
    ::ohos::book::store::FancyBook cpp_result = ::ohos::book::store::MakeFancyBook();
    if (::taihe::has_error()) { return ani_object{}; }
    ani_object ani_result = ohos_book_store_FancyBook_intoANI(env, cpp_result);
    return ani_result;
}
static void ohos_book_store_SaveBookToInternet_ANIFunc([[maybe_unused]] ani_env *env, ani_string ani_arg_url) {
    ::taihe::set_env(env);
    ani_size cpp_arg_url_len;
    env->String_GetUTF8Size(ani_arg_url, &cpp_arg_url_len);
    TString cpp_arg_url_tstr;
    char* cpp_arg_url_buf = tstr_initialize(&cpp_arg_url_tstr, cpp_arg_url_len + 1);
    env->String_GetUTF8(ani_arg_url, cpp_arg_url_buf, cpp_arg_url_len + 1, &cpp_arg_url_len);
    cpp_arg_url_buf[cpp_arg_url_len] = '\0';
    cpp_arg_url_tstr.length = cpp_arg_url_len;
    taihe::string cpp_arg_url = taihe::string(cpp_arg_url_tstr);
    ::ohos::book::store::SaveBookToInternet(cpp_arg_url);
}
static void ohos_book_store_SaveBookToFile_ANIFunc([[maybe_unused]] ani_env *env, ani_object ani_arg_p) {
    ::taihe::set_env(env);
    ::ohos::book::store::Path cpp_arg_p = ohos_book_store_Path_fromANI(env, ani_arg_p);
    ::ohos::book::store::SaveBookToFile(cpp_arg_p);
}
static ani_string ohos_book_store_uploadBook_ANIFunc([[maybe_unused]] ani_env *env, ani_object ani_arg_b) {
    ::taihe::set_env(env);
    ::ohos::book::store::Book cpp_arg_b = ohos_book_store_Book_fromANI(env, ani_arg_b);
    ::taihe::string cpp_result = ::ohos::book::store::uploadBook(cpp_arg_b);
    if (::taihe::has_error()) { return ani_string{}; }
    ani_string ani_result;
    env->String_NewUTF8(cpp_result.c_str(), cpp_result.size(), &ani_result);
    return ani_result;
}
static void ohos_book_store_onBookSold_ANIFunc([[maybe_unused]] ani_env *env) {
    ::taihe::set_env(env);
    ::ohos::book::store::onBookSold();
}
static void ohos_book_store_onNewBook_ANIFunc([[maybe_unused]] ani_env *env) {
    ::taihe::set_env(env);
    ::ohos::book::store::onNewBook();
}
static ani_boolean ohos_book_store_IsString_ANIFunc([[maybe_unused]] ani_env *env, ani_ref ani_arg_s) {
    ::taihe::set_env(env);
    uintptr_t cpp_arg_s = (uintptr_t)ani_arg_s;
    bool cpp_result = ::ohos::book::store::IsString(cpp_arg_s);
    if (::taihe::has_error()) { return ani_boolean{}; }
    ani_boolean ani_result = (bool)cpp_result;
    return ani_result;
}
static ani_array_ref ohos_book_store_GetStringArray_ANIFunc([[maybe_unused]] ani_env *env) {
    ::taihe::set_env(env);
    ::taihe::array<uintptr_t> cpp_result = ::ohos::book::store::GetStringArray();
    if (::taihe::has_error()) { return ani_array_ref{}; }
    size_t ani_result_size = cpp_result.size();
    ani_array_ref ani_result;
    ani_class ani_result_cls;
    env->FindClass("Lstd/core/Object;", &ani_result_cls);
ani_ref ani_undefined;
    env->GetUndefined(&ani_undefined);
    env->Array_New_Ref(ani_result_cls, ani_result_size, ani_undefined, &ani_result);
    for (size_t ani_result_i = 0; ani_result_i < ani_result_size; ani_result_i++) {
        ani_ref ani_result_item = (ani_ref)cpp_result.data()[ani_result_i];
        env->Array_Set_Ref(ani_result, ani_result_i, ani_result_item);
    }
    return ani_result;
}
static void ohos_book_store_Bookstore_addBook_ANIFunc([[maybe_unused]] ani_env *env, [[maybe_unused]] ani_object object, ani_object ani_arg_book, ani_double ani_arg_price, ani_int ani_arg_count) {
    ::taihe::set_env(env);
    ani_long ani_data_ptr;
    env->Object_GetPropertyByName_Long(object, "_data_ptr", reinterpret_cast<ani_long*>(&ani_data_ptr));
    ani_long ani_vtbl_ptr;
    env->Object_GetPropertyByName_Long(object, "_vtbl_ptr", reinterpret_cast<ani_long*>(&ani_vtbl_ptr));
    DataBlockHead* cpp_data_ptr = reinterpret_cast<DataBlockHead*>(ani_data_ptr);
    ohos_book_store_Bookstore_vtable* cpp_vtbl_ptr = reinterpret_cast<ohos_book_store_Bookstore_vtable*>(ani_vtbl_ptr);
    ::ohos::book::store::weak::Bookstore cpp_iface = ::ohos::book::store::weak::Bookstore({cpp_vtbl_ptr, cpp_data_ptr});
    ::ohos::book::store::Book cpp_arg_book = ohos_book_store_Book_fromANI(env, ani_arg_book);
    double cpp_arg_price = (double)ani_arg_price;
    int32_t cpp_arg_count = (int32_t)ani_arg_count;
    ::ohos::book::store::weak::Bookstore(cpp_iface)->addBook(cpp_arg_book, cpp_arg_price, cpp_arg_count);
}
static void ohos_book_store_Bookstore_saleBook_ANIFunc([[maybe_unused]] ani_env *env, [[maybe_unused]] ani_object object, ani_object ani_arg_book) {
    ::taihe::set_env(env);
    ani_long ani_data_ptr;
    env->Object_GetPropertyByName_Long(object, "_data_ptr", reinterpret_cast<ani_long*>(&ani_data_ptr));
    ani_long ani_vtbl_ptr;
    env->Object_GetPropertyByName_Long(object, "_vtbl_ptr", reinterpret_cast<ani_long*>(&ani_vtbl_ptr));
    DataBlockHead* cpp_data_ptr = reinterpret_cast<DataBlockHead*>(ani_data_ptr);
    ohos_book_store_Bookstore_vtable* cpp_vtbl_ptr = reinterpret_cast<ohos_book_store_Bookstore_vtable*>(ani_vtbl_ptr);
    ::ohos::book::store::weak::Bookstore cpp_iface = ::ohos::book::store::weak::Bookstore({cpp_vtbl_ptr, cpp_data_ptr});
    ::ohos::book::store::Book cpp_arg_book = ohos_book_store_Book_fromANI(env, ani_arg_book);
    ::ohos::book::store::weak::Bookstore(cpp_iface)->saleBook(cpp_arg_book);
}
static ani_double ohos_book_store_Bookstore_getDiscount_ANIFunc([[maybe_unused]] ani_env *env, [[maybe_unused]] ani_object object) {
    ::taihe::set_env(env);
    ani_long ani_data_ptr;
    env->Object_GetPropertyByName_Long(object, "_data_ptr", reinterpret_cast<ani_long*>(&ani_data_ptr));
    ani_long ani_vtbl_ptr;
    env->Object_GetPropertyByName_Long(object, "_vtbl_ptr", reinterpret_cast<ani_long*>(&ani_vtbl_ptr));
    DataBlockHead* cpp_data_ptr = reinterpret_cast<DataBlockHead*>(ani_data_ptr);
    ohos_book_store_Bookstore_vtable* cpp_vtbl_ptr = reinterpret_cast<ohos_book_store_Bookstore_vtable*>(ani_vtbl_ptr);
    ::ohos::book::store::weak::Bookstore cpp_iface = ::ohos::book::store::weak::Bookstore({cpp_vtbl_ptr, cpp_data_ptr});
    double cpp_result = ::ohos::book::store::weak::Bookstore(cpp_iface)->getDiscount();
    if (::taihe::has_error()) { return ani_double{}; }
    ani_double ani_result = (double)cpp_result;
    return ani_result;
}
static void ohos_book_store_Bookstore_setDiscount_ANIFunc([[maybe_unused]] ani_env *env, [[maybe_unused]] ani_object object, ani_double ani_arg_percent) {
    ::taihe::set_env(env);
    ani_long ani_data_ptr;
    env->Object_GetPropertyByName_Long(object, "_data_ptr", reinterpret_cast<ani_long*>(&ani_data_ptr));
    ani_long ani_vtbl_ptr;
    env->Object_GetPropertyByName_Long(object, "_vtbl_ptr", reinterpret_cast<ani_long*>(&ani_vtbl_ptr));
    DataBlockHead* cpp_data_ptr = reinterpret_cast<DataBlockHead*>(ani_data_ptr);
    ohos_book_store_Bookstore_vtable* cpp_vtbl_ptr = reinterpret_cast<ohos_book_store_Bookstore_vtable*>(ani_vtbl_ptr);
    ::ohos::book::store::weak::Bookstore cpp_iface = ::ohos::book::store::weak::Bookstore({cpp_vtbl_ptr, cpp_data_ptr});
    double cpp_arg_percent = (double)ani_arg_percent;
    ::ohos::book::store::weak::Bookstore(cpp_iface)->setDiscount(cpp_arg_percent);
}
static ani_double ohos_book_store_Bookstore_getTotalSales_ANIFunc([[maybe_unused]] ani_env *env, [[maybe_unused]] ani_object object) {
    ::taihe::set_env(env);
    ani_long ani_data_ptr;
    env->Object_GetPropertyByName_Long(object, "_data_ptr", reinterpret_cast<ani_long*>(&ani_data_ptr));
    ani_long ani_vtbl_ptr;
    env->Object_GetPropertyByName_Long(object, "_vtbl_ptr", reinterpret_cast<ani_long*>(&ani_vtbl_ptr));
    DataBlockHead* cpp_data_ptr = reinterpret_cast<DataBlockHead*>(ani_data_ptr);
    ohos_book_store_Bookstore_vtable* cpp_vtbl_ptr = reinterpret_cast<ohos_book_store_Bookstore_vtable*>(ani_vtbl_ptr);
    ::ohos::book::store::weak::Bookstore cpp_iface = ::ohos::book::store::weak::Bookstore({cpp_vtbl_ptr, cpp_data_ptr});
    double cpp_result = ::ohos::book::store::weak::Bookstore(cpp_iface)->getTotalSales();
    if (::taihe::has_error()) { return ani_double{}; }
    ani_double ani_result = (double)cpp_result;
    return ani_result;
}
static ani_double ohos_book_store_HasPrice_getPrice_ANIFunc([[maybe_unused]] ani_env *env, [[maybe_unused]] ani_object object) {
    ::taihe::set_env(env);
    ani_long ani_data_ptr;
    env->Object_GetPropertyByName_Long(object, "_data_ptr", reinterpret_cast<ani_long*>(&ani_data_ptr));
    ani_long ani_vtbl_ptr;
    env->Object_GetPropertyByName_Long(object, "_vtbl_ptr", reinterpret_cast<ani_long*>(&ani_vtbl_ptr));
    DataBlockHead* cpp_data_ptr = reinterpret_cast<DataBlockHead*>(ani_data_ptr);
    ohos_book_store_HasPrice_vtable* cpp_vtbl_ptr = reinterpret_cast<ohos_book_store_HasPrice_vtable*>(ani_vtbl_ptr);
    ::ohos::book::store::weak::HasPrice cpp_iface = ::ohos::book::store::weak::HasPrice({cpp_vtbl_ptr, cpp_data_ptr});
    double cpp_result = ::ohos::book::store::weak::HasPrice(cpp_iface)->getPrice();
    if (::taihe::has_error()) { return ani_double{}; }
    ani_double ani_result = (double)cpp_result;
    return ani_result;
}
static ani_double ohos_book_store_HasDiscount_getDiscount_ANIFunc([[maybe_unused]] ani_env *env, [[maybe_unused]] ani_object object) {
    ::taihe::set_env(env);
    ani_long ani_data_ptr;
    env->Object_GetPropertyByName_Long(object, "_data_ptr", reinterpret_cast<ani_long*>(&ani_data_ptr));
    ani_long ani_vtbl_ptr;
    env->Object_GetPropertyByName_Long(object, "_vtbl_ptr", reinterpret_cast<ani_long*>(&ani_vtbl_ptr));
    DataBlockHead* cpp_data_ptr = reinterpret_cast<DataBlockHead*>(ani_data_ptr);
    ohos_book_store_HasDiscount_vtable* cpp_vtbl_ptr = reinterpret_cast<ohos_book_store_HasDiscount_vtable*>(ani_vtbl_ptr);
    ::ohos::book::store::weak::HasDiscount cpp_iface = ::ohos::book::store::weak::HasDiscount({cpp_vtbl_ptr, cpp_data_ptr});
    double cpp_result = ::ohos::book::store::weak::HasDiscount(cpp_iface)->getDiscount();
    if (::taihe::has_error()) { return ani_double{}; }
    ani_double ani_result = (double)cpp_result;
    return ani_result;
}
static ani_double ohos_book_store_HasDiscount_getPrice_ANIFunc([[maybe_unused]] ani_env *env, [[maybe_unused]] ani_object object) {
    ::taihe::set_env(env);
    ani_long ani_data_ptr;
    env->Object_GetPropertyByName_Long(object, "_data_ptr", reinterpret_cast<ani_long*>(&ani_data_ptr));
    ani_long ani_vtbl_ptr;
    env->Object_GetPropertyByName_Long(object, "_vtbl_ptr", reinterpret_cast<ani_long*>(&ani_vtbl_ptr));
    DataBlockHead* cpp_data_ptr = reinterpret_cast<DataBlockHead*>(ani_data_ptr);
    ohos_book_store_HasDiscount_vtable* cpp_vtbl_ptr = reinterpret_cast<ohos_book_store_HasDiscount_vtable*>(ani_vtbl_ptr);
    ::ohos::book::store::weak::HasDiscount cpp_iface = ::ohos::book::store::weak::HasDiscount({cpp_vtbl_ptr, cpp_data_ptr});
    double cpp_result = ::ohos::book::store::weak::HasPrice(cpp_iface)->getPrice();
    if (::taihe::has_error()) { return ani_double{}; }
    ani_double ani_result = (double)cpp_result;
    return ani_result;
}
static ani_string ohos_book_store_HasPublisher_getPublisher_ANIFunc([[maybe_unused]] ani_env *env, [[maybe_unused]] ani_object object) {
    ::taihe::set_env(env);
    ani_long ani_data_ptr;
    env->Object_GetPropertyByName_Long(object, "_data_ptr", reinterpret_cast<ani_long*>(&ani_data_ptr));
    ani_long ani_vtbl_ptr;
    env->Object_GetPropertyByName_Long(object, "_vtbl_ptr", reinterpret_cast<ani_long*>(&ani_vtbl_ptr));
    DataBlockHead* cpp_data_ptr = reinterpret_cast<DataBlockHead*>(ani_data_ptr);
    ohos_book_store_HasPublisher_vtable* cpp_vtbl_ptr = reinterpret_cast<ohos_book_store_HasPublisher_vtable*>(ani_vtbl_ptr);
    ::ohos::book::store::weak::HasPublisher cpp_iface = ::ohos::book::store::weak::HasPublisher({cpp_vtbl_ptr, cpp_data_ptr});
    ::taihe::string cpp_result = ::ohos::book::store::weak::HasPublisher(cpp_iface)->getPublisher();
    if (::taihe::has_error()) { return ani_string{}; }
    ani_string ani_result;
    env->String_NewUTF8(cpp_result.c_str(), cpp_result.size(), &ani_result);
    return ani_result;
}
static ani_string ohos_book_store_FancyBook_getTitle_ANIFunc([[maybe_unused]] ani_env *env, [[maybe_unused]] ani_object object) {
    ::taihe::set_env(env);
    ani_long ani_data_ptr;
    env->Object_GetPropertyByName_Long(object, "_data_ptr", reinterpret_cast<ani_long*>(&ani_data_ptr));
    ani_long ani_vtbl_ptr;
    env->Object_GetPropertyByName_Long(object, "_vtbl_ptr", reinterpret_cast<ani_long*>(&ani_vtbl_ptr));
    DataBlockHead* cpp_data_ptr = reinterpret_cast<DataBlockHead*>(ani_data_ptr);
    ohos_book_store_FancyBook_vtable* cpp_vtbl_ptr = reinterpret_cast<ohos_book_store_FancyBook_vtable*>(ani_vtbl_ptr);
    ::ohos::book::store::weak::FancyBook cpp_iface = ::ohos::book::store::weak::FancyBook({cpp_vtbl_ptr, cpp_data_ptr});
    ::taihe::string cpp_result = ::ohos::book::store::weak::FancyBook(cpp_iface)->getTitle();
    if (::taihe::has_error()) { return ani_string{}; }
    ani_string ani_result;
    env->String_NewUTF8(cpp_result.c_str(), cpp_result.size(), &ani_result);
    return ani_result;
}
static ani_string ohos_book_store_FancyBook_getPublisher_ANIFunc([[maybe_unused]] ani_env *env, [[maybe_unused]] ani_object object) {
    ::taihe::set_env(env);
    ani_long ani_data_ptr;
    env->Object_GetPropertyByName_Long(object, "_data_ptr", reinterpret_cast<ani_long*>(&ani_data_ptr));
    ani_long ani_vtbl_ptr;
    env->Object_GetPropertyByName_Long(object, "_vtbl_ptr", reinterpret_cast<ani_long*>(&ani_vtbl_ptr));
    DataBlockHead* cpp_data_ptr = reinterpret_cast<DataBlockHead*>(ani_data_ptr);
    ohos_book_store_FancyBook_vtable* cpp_vtbl_ptr = reinterpret_cast<ohos_book_store_FancyBook_vtable*>(ani_vtbl_ptr);
    ::ohos::book::store::weak::FancyBook cpp_iface = ::ohos::book::store::weak::FancyBook({cpp_vtbl_ptr, cpp_data_ptr});
    ::taihe::string cpp_result = ::ohos::book::store::weak::HasPublisher(cpp_iface)->getPublisher();
    if (::taihe::has_error()) { return ani_string{}; }
    ani_string ani_result;
    env->String_NewUTF8(cpp_result.c_str(), cpp_result.size(), &ani_result);
    return ani_result;
}
static ani_double ohos_book_store_FancyBook_getDiscount_ANIFunc([[maybe_unused]] ani_env *env, [[maybe_unused]] ani_object object) {
    ::taihe::set_env(env);
    ani_long ani_data_ptr;
    env->Object_GetPropertyByName_Long(object, "_data_ptr", reinterpret_cast<ani_long*>(&ani_data_ptr));
    ani_long ani_vtbl_ptr;
    env->Object_GetPropertyByName_Long(object, "_vtbl_ptr", reinterpret_cast<ani_long*>(&ani_vtbl_ptr));
    DataBlockHead* cpp_data_ptr = reinterpret_cast<DataBlockHead*>(ani_data_ptr);
    ohos_book_store_FancyBook_vtable* cpp_vtbl_ptr = reinterpret_cast<ohos_book_store_FancyBook_vtable*>(ani_vtbl_ptr);
    ::ohos::book::store::weak::FancyBook cpp_iface = ::ohos::book::store::weak::FancyBook({cpp_vtbl_ptr, cpp_data_ptr});
    double cpp_result = ::ohos::book::store::weak::HasDiscount(cpp_iface)->getDiscount();
    if (::taihe::has_error()) { return ani_double{}; }
    ani_double ani_result = (double)cpp_result;
    return ani_result;
}
static ani_double ohos_book_store_FancyBook_getPrice_ANIFunc([[maybe_unused]] ani_env *env, [[maybe_unused]] ani_object object) {
    ::taihe::set_env(env);
    ani_long ani_data_ptr;
    env->Object_GetPropertyByName_Long(object, "_data_ptr", reinterpret_cast<ani_long*>(&ani_data_ptr));
    ani_long ani_vtbl_ptr;
    env->Object_GetPropertyByName_Long(object, "_vtbl_ptr", reinterpret_cast<ani_long*>(&ani_vtbl_ptr));
    DataBlockHead* cpp_data_ptr = reinterpret_cast<DataBlockHead*>(ani_data_ptr);
    ohos_book_store_FancyBook_vtable* cpp_vtbl_ptr = reinterpret_cast<ohos_book_store_FancyBook_vtable*>(ani_vtbl_ptr);
    ::ohos::book::store::weak::FancyBook cpp_iface = ::ohos::book::store::weak::FancyBook({cpp_vtbl_ptr, cpp_data_ptr});
    double cpp_result = ::ohos::book::store::weak::HasPrice(cpp_iface)->getPrice();
    if (::taihe::has_error()) { return ani_double{}; }
    ani_double ani_result = (double)cpp_result;
    return ani_result;
}
namespace ohos::book::store {
ani_status ANIRegister(ani_env *env) {
    {
        ani_module ani_env;
        if (ANI_OK != env->FindModule("Lohos/book/store;", &ani_env)) {
            return ANI_ERROR;
        }
        ani_native_function methods[] = {
            {"ConstructBook_inner", nullptr, reinterpret_cast<void*>(ohos_book_store_ConstructBook_ANIFunc)},

            {"PrintBook_inner", nullptr, reinterpret_cast<void*>(ohos_book_store_PrintBook_ANIFunc)},

            {"MapBookToYear_inner", nullptr, reinterpret_cast<void*>(ohos_book_store_MapBookToYear_ANIFunc)},

            {"PrintBooksWithFilter_inner", nullptr, reinterpret_cast<void*>(ohos_book_store_PrintBooksWithFilter_ANIFunc)},

            {"CreateBookstore_inner", nullptr, reinterpret_cast<void*>(ohos_book_store_CreateBookstore_ANIFunc)},

            {"SayHello_inner", nullptr, reinterpret_cast<void*>(ohos_book_store_SayHello_ANIFunc)},

            {"PrintBookAdvanced_inner", nullptr, reinterpret_cast<void*>(ohos_book_store_PrintBookAdvanced_ANIFunc)},

            {"MakeFancyBook_inner", nullptr, reinterpret_cast<void*>(ohos_book_store_MakeFancyBook_ANIFunc)},

            {"SaveBookToInternet_inner", nullptr, reinterpret_cast<void*>(ohos_book_store_SaveBookToInternet_ANIFunc)},

            {"SaveBookToFile_inner", nullptr, reinterpret_cast<void*>(ohos_book_store_SaveBookToFile_ANIFunc)},

            {"uploadBook_inner", nullptr, reinterpret_cast<void*>(ohos_book_store_uploadBook_ANIFunc)},

            {"onBookSold_inner", nullptr, reinterpret_cast<void*>(ohos_book_store_onBookSold_ANIFunc)},

            {"onNewBook_inner", nullptr, reinterpret_cast<void*>(ohos_book_store_onNewBook_ANIFunc)},

            {"IsString_inner", nullptr, reinterpret_cast<void*>(ohos_book_store_IsString_ANIFunc)},

            {"GetStringArray_inner", nullptr, reinterpret_cast<void*>(ohos_book_store_GetStringArray_ANIFunc)},

        };
        if (ANI_OK != env->Module_BindNativeFunctions(ani_env, methods, sizeof(methods) / sizeof(ani_native_function))) {
            return ANI_ERROR;
        }
    }
    {
        ani_class ani_env;
        if (ANI_OK != env->FindClass("Lohos/book/store/Bookstore;", &ani_env)) {
            return ANI_ERROR;
        }
        ani_native_function methods[] = {
            {"addBook_inner", nullptr, reinterpret_cast<void*>(ohos_book_store_Bookstore_addBook_ANIFunc)},

            {"saleBook_inner", nullptr, reinterpret_cast<void*>(ohos_book_store_Bookstore_saleBook_ANIFunc)},

            {"getDiscount_inner", nullptr, reinterpret_cast<void*>(ohos_book_store_Bookstore_getDiscount_ANIFunc)},

            {"setDiscount_inner", nullptr, reinterpret_cast<void*>(ohos_book_store_Bookstore_setDiscount_ANIFunc)},

            {"getTotalSales_inner", nullptr, reinterpret_cast<void*>(ohos_book_store_Bookstore_getTotalSales_ANIFunc)},

        };
        if (ANI_OK != env->Class_BindNativeMethods(ani_env, methods, sizeof(methods) / sizeof(ani_native_function))) {
            return ANI_ERROR;
        }
    }
    {
        ani_class ani_env;
        if (ANI_OK != env->FindClass("Lohos/book/store/HasPrice_inner;", &ani_env)) {
            return ANI_ERROR;
        }
        ani_native_function methods[] = {
            {"getPrice_inner", nullptr, reinterpret_cast<void*>(ohos_book_store_HasPrice_getPrice_ANIFunc)},

        };
        if (ANI_OK != env->Class_BindNativeMethods(ani_env, methods, sizeof(methods) / sizeof(ani_native_function))) {
            return ANI_ERROR;
        }
    }
    {
        ani_class ani_env;
        if (ANI_OK != env->FindClass("Lohos/book/store/HasDiscount_inner;", &ani_env)) {
            return ANI_ERROR;
        }
        ani_native_function methods[] = {
            {"getDiscount_inner", nullptr, reinterpret_cast<void*>(ohos_book_store_HasDiscount_getDiscount_ANIFunc)},

            {"getPrice_inner", nullptr, reinterpret_cast<void*>(ohos_book_store_HasDiscount_getPrice_ANIFunc)},

        };
        if (ANI_OK != env->Class_BindNativeMethods(ani_env, methods, sizeof(methods) / sizeof(ani_native_function))) {
            return ANI_ERROR;
        }
    }
    {
        ani_class ani_env;
        if (ANI_OK != env->FindClass("Lohos/book/store/HasPublisher_inner;", &ani_env)) {
            return ANI_ERROR;
        }
        ani_native_function methods[] = {
            {"getPublisher_inner", nullptr, reinterpret_cast<void*>(ohos_book_store_HasPublisher_getPublisher_ANIFunc)},

        };
        if (ANI_OK != env->Class_BindNativeMethods(ani_env, methods, sizeof(methods) / sizeof(ani_native_function))) {
            return ANI_ERROR;
        }
    }
    {
        ani_class ani_env;
        if (ANI_OK != env->FindClass("Lohos/book/store/FancyBook;", &ani_env)) {
            return ANI_ERROR;
        }
        ani_native_function methods[] = {
            {"getTitle_inner", nullptr, reinterpret_cast<void*>(ohos_book_store_FancyBook_getTitle_ANIFunc)},

            {"getPublisher_inner", nullptr, reinterpret_cast<void*>(ohos_book_store_FancyBook_getPublisher_ANIFunc)},

            {"getDiscount_inner", nullptr, reinterpret_cast<void*>(ohos_book_store_FancyBook_getDiscount_ANIFunc)},

            {"getPrice_inner", nullptr, reinterpret_cast<void*>(ohos_book_store_FancyBook_getPrice_ANIFunc)},

        };
        if (ANI_OK != env->Class_BindNativeMethods(ani_env, methods, sizeof(methods) / sizeof(ani_native_function))) {
            return ANI_ERROR;
        }
    }
    {
        ani_class ani_env;
        if (ANI_OK != env->FindClass("Lohos/book/store/Path_inner;", &ani_env)) {
            return ANI_ERROR;
        }
        ani_native_function methods[] = {
        };
        if (ANI_OK != env->Class_BindNativeMethods(ani_env, methods, sizeof(methods) / sizeof(ani_native_function))) {
            return ANI_ERROR;
        }
    }
    {
        ani_class ani_env;
        if (ANI_OK != env->FindClass("Lohos/book/store/Foo_inner;", &ani_env)) {
            return ANI_ERROR;
        }
        ani_native_function methods[] = {
        };
        if (ANI_OK != env->Class_BindNativeMethods(ani_env, methods, sizeof(methods) / sizeof(ani_native_function))) {
            return ANI_ERROR;
        }
    }
    return ANI_OK;
}
}
