#include "ohos.book.store.proj.hpp"
#include "ohos.book.store.impl.hpp"
#include "taihe/runtime.hpp"
#include "stdexcept"

using namespace taihe;
using namespace ohos::book::store;

namespace {
// To be implemented.

class BookstoreImpl {
public:
    BookstoreImpl() {
        // Don't forget to implement the constructor.
    }

    void addBook(Book const& book, double price, int32_t count) {
        TH_THROW(std::runtime_error, "addBook not implemented");
    }

    void saleBook(Book const& book) {
        TH_THROW(std::runtime_error, "saleBook not implemented");
    }

    double getDiscount() {
        TH_THROW(std::runtime_error, "getDiscount not implemented");
    }

    void setDiscount(double percent) {
        TH_THROW(std::runtime_error, "setDiscount not implemented");
    }

    double getTotalSales() {
        TH_THROW(std::runtime_error, "getTotalSales not implemented");
    }
};

class HasPriceImpl {
public:
    HasPriceImpl() {
        // Don't forget to implement the constructor.
    }

    double getPrice() {
        TH_THROW(std::runtime_error, "getPrice not implemented");
    }
};

class HasDiscountImpl {
public:
    HasDiscountImpl() {
        // Don't forget to implement the constructor.
    }

    double getDiscount() {
        TH_THROW(std::runtime_error, "getDiscount not implemented");
    }

    double getPrice() {
        TH_THROW(std::runtime_error, "getPrice not implemented");
    }
};

class HasPublisherImpl {
public:
    HasPublisherImpl() {
        // Don't forget to implement the constructor.
    }

    string getPublisher() {
        TH_THROW(std::runtime_error, "getPublisher not implemented");
    }
};

class FancyBookImpl {
public:
    FancyBookImpl() {
        // Don't forget to implement the constructor.
    }

    string getTitle() {
        TH_THROW(std::runtime_error, "getTitle not implemented");
    }

    string getPublisher() {
        TH_THROW(std::runtime_error, "getPublisher not implemented");
    }

    double getDiscount() {
        TH_THROW(std::runtime_error, "getDiscount not implemented");
    }

    double getPrice() {
        TH_THROW(std::runtime_error, "getPrice not implemented");
    }
};

class PathImpl {
public:
    PathImpl() {
        // Don't forget to implement the constructor.
    }
};

class FooImpl {
public:
    FooImpl() {
        // Don't forget to implement the constructor.
    }
};

Book ConstructBook(string_view title, int32_t year, Category kind) {
    TH_THROW(std::runtime_error, "ConstructBook not implemented");
}

void PrintBook(Book const& b) {
    TH_THROW(std::runtime_error, "PrintBook not implemented");
}

map<string, int32_t> MapBookToYear(MapOption const& opt) {
    TH_THROW(std::runtime_error, "MapBookToYear not implemented");
}

void PrintBooksWithFilter(array_view<Book> books, optional_view<callback<bool(Book const&)>> filter) {
    TH_THROW(std::runtime_error, "PrintBooksWithFilter not implemented");
}

Bookstore CreateBookstore() {
    // The parameters in the make_holder function should be of the same type
    // as the parameters in the constructor of the actual implementation class.
    return make_holder<BookstoreImpl, Bookstore>();
}

void SayHello() {
    TH_THROW(std::runtime_error, "SayHello not implemented");
}

void PrintBookAdvanced(CppOrRustBook const& book) {
    TH_THROW(std::runtime_error, "PrintBookAdvanced not implemented");
}

FancyBook MakeFancyBook() {
    // The parameters in the make_holder function should be of the same type
    // as the parameters in the constructor of the actual implementation class.
    return make_holder<FancyBookImpl, FancyBook>();
}

void SaveBookToInternet(string_view url) {
    TH_THROW(std::runtime_error, "SaveBookToInternet not implemented");
}

void SaveBookToFile(weak::Path p) {
    TH_THROW(std::runtime_error, "SaveBookToFile not implemented");
}

string uploadBook(Book const& b) {
    TH_THROW(std::runtime_error, "uploadBook not implemented");
}

void onBookSold() {
    TH_THROW(std::runtime_error, "onBookSold not implemented");
}

void onNewBook() {
    TH_THROW(std::runtime_error, "onNewBook not implemented");
}

bool IsString(uintptr_t s) {
    TH_THROW(std::runtime_error, "IsString not implemented");
}

array<uintptr_t> GetStringArray() {
    TH_THROW(std::runtime_error, "GetStringArray not implemented");
}
}  // namespace

TH_EXPORT_CPP_API_ConstructBook(ConstructBook);
TH_EXPORT_CPP_API_PrintBook(PrintBook);
TH_EXPORT_CPP_API_MapBookToYear(MapBookToYear);
TH_EXPORT_CPP_API_PrintBooksWithFilter(PrintBooksWithFilter);
TH_EXPORT_CPP_API_CreateBookstore(CreateBookstore);
TH_EXPORT_CPP_API_SayHello(SayHello);
TH_EXPORT_CPP_API_PrintBookAdvanced(PrintBookAdvanced);
TH_EXPORT_CPP_API_MakeFancyBook(MakeFancyBook);
TH_EXPORT_CPP_API_SaveBookToInternet(SaveBookToInternet);
TH_EXPORT_CPP_API_SaveBookToFile(SaveBookToFile);
TH_EXPORT_CPP_API_uploadBook(uploadBook);
TH_EXPORT_CPP_API_onBookSold(onBookSold);
TH_EXPORT_CPP_API_onNewBook(onNewBook);
TH_EXPORT_CPP_API_IsString(IsString);
TH_EXPORT_CPP_API_GetStringArray(GetStringArray);
