#pragma once
#include "taihe/object.hpp"
#include "notification.INotificationService.proj.0.hpp"
#include "notification.INotificationService.abi.1.h"
#include "user.IUser.proj.0.hpp"
namespace notification::weak {
struct INotificationService {
    static constexpr bool is_holder = false;
    struct notification_INotificationService_t m_handle;
    explicit INotificationService(struct notification_INotificationService_t handle) : m_handle(handle) {}
    explicit INotificationService(::taihe::data_view other)
        : INotificationService(notification_INotificationService_dynamic(other.data_ptr)) {}
    operator ::taihe::data_view() const& {
        struct notification_INotificationService_t ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct notification_INotificationService_t ret_handle = notification_INotificationService_copy(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    struct virtual_type {
        void sendMessage(::user::weak::IUser a) const&;
    };
    template<typename Impl>
    struct methods_impl {
        static void sendMessage(struct notification_INotificationService_t tobj, struct user_IUser_t a);
    };
    template<typename Impl>
    static constexpr notification_INotificationService_ftable ftbl_impl = {
        .sendMessage = &methods_impl<Impl>::sendMessage,
    };
    template<typename Impl>
    static constexpr notification_INotificationService_vtable vtbl_impl = {
        .ftbl_ptr_0 = &::notification::weak::INotificationService::template ftbl_impl<Impl>,
    };
    template<typename Impl>
    static constexpr IdMapItem idmap_impl[1] = {
        {&notification_INotificationService_i, &vtbl_impl<Impl>.ftbl_ptr_0},
    };
    static constexpr void const* iid = &notification_INotificationService_i;
    using vtable_t = notification_INotificationService_vtable;
    explicit operator bool() const& { return m_handle.vtbl_ptr; }
    virtual_type const& operator*() const& {
        return *reinterpret_cast<virtual_type const*>(&m_handle);
    }
    virtual_type const* operator->() const& {
        return reinterpret_cast<virtual_type const*>(&m_handle);
    }
};
}
namespace notification {
struct INotificationService : public ::notification::weak::INotificationService {
    static constexpr bool is_holder = true;
    explicit INotificationService(struct notification_INotificationService_t handle) : ::notification::weak::INotificationService(handle) {}
    INotificationService& operator=(::notification::INotificationService other) {
        ::std::swap(m_handle, other.m_handle);
        return *this;
    }
    ~INotificationService() {
        notification_INotificationService_drop(m_handle);
    }
    explicit INotificationService(::taihe::data_holder other)
        : INotificationService(notification_INotificationService_dynamic(other.data_ptr)) {
        other.data_ptr = nullptr;
    }
    operator ::taihe::data_view() const& {
        struct notification_INotificationService_t ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct notification_INotificationService_t ret_handle = notification_INotificationService_copy(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() && {
        struct notification_INotificationService_t ret_handle = m_handle;
        m_handle.data_ptr = nullptr;
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    INotificationService(::notification::weak::INotificationService const& other)
        : INotificationService(notification_INotificationService_copy(other.m_handle)) {}
    INotificationService(::notification::INotificationService const& other)
        : INotificationService(notification_INotificationService_copy(other.m_handle)) {}
    INotificationService(::notification::INotificationService&& other)
        : INotificationService(other.m_handle) {
        other.m_handle.data_ptr = nullptr;
    }
};
}
namespace taihe {
template<>
struct as_abi<::notification::INotificationService> {
    using type = struct notification_INotificationService_t;
};
template<>
struct as_abi<::notification::weak::INotificationService> {
    using type = struct notification_INotificationService_t;
};
template<>
struct as_param<::notification::INotificationService> {
    using type = ::notification::weak::INotificationService;
};
}
