#pragma once
#include "taihe/object.hpp"
#include "user.IUser.proj.0.hpp"
#include "user.IUser.abi.1.h"
#include "taihe/string.hpp"
namespace user::weak {
struct IUser {
    static constexpr bool is_holder = false;
    struct user_IUser_t m_handle;
    explicit IUser(struct user_IUser_t handle) : m_handle(handle) {}
    explicit IUser(::taihe::data_view other)
        : IUser(user_IUser_dynamic(other.data_ptr)) {}
    operator ::taihe::data_view() const& {
        struct user_IUser_t ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct user_IUser_t ret_handle = user_IUser_copy(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    struct virtual_type {
        ::taihe::string getEmail() const&;
        void setEmail(::taihe::string_view path) const&;
    };
    template<typename Impl>
    struct methods_impl {
        static struct TString getEmail(struct user_IUser_t tobj);
        static void setEmail(struct user_IUser_t tobj, struct TString path);
    };
    template<typename Impl>
    static constexpr user_IUser_ftable ftbl_impl = {
        .getEmail = &methods_impl<Impl>::getEmail,
        .setEmail = &methods_impl<Impl>::setEmail,
    };
    template<typename Impl>
    static constexpr user_IUser_vtable vtbl_impl = {
        .ftbl_ptr_0 = &::user::weak::IUser::template ftbl_impl<Impl>,
    };
    template<typename Impl>
    static constexpr IdMapItem idmap_impl[1] = {
        {&user_IUser_i, &vtbl_impl<Impl>.ftbl_ptr_0},
    };
    static constexpr void const* iid = &user_IUser_i;
    using vtable_t = user_IUser_vtable;
    explicit operator bool() const& { return m_handle.vtbl_ptr; }
    virtual_type const& operator*() const& {
        return *reinterpret_cast<virtual_type const*>(&m_handle);
    }
    virtual_type const* operator->() const& {
        return reinterpret_cast<virtual_type const*>(&m_handle);
    }
};
}
namespace user {
struct IUser : public ::user::weak::IUser {
    static constexpr bool is_holder = true;
    explicit IUser(struct user_IUser_t handle) : ::user::weak::IUser(handle) {}
    IUser& operator=(::user::IUser other) {
        ::std::swap(m_handle, other.m_handle);
        return *this;
    }
    ~IUser() {
        user_IUser_drop(m_handle);
    }
    explicit IUser(::taihe::data_holder other)
        : IUser(user_IUser_dynamic(other.data_ptr)) {
        other.data_ptr = nullptr;
    }
    operator ::taihe::data_view() const& {
        struct user_IUser_t ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct user_IUser_t ret_handle = user_IUser_copy(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() && {
        struct user_IUser_t ret_handle = m_handle;
        m_handle.data_ptr = nullptr;
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    IUser(::user::weak::IUser const& other)
        : IUser(user_IUser_copy(other.m_handle)) {}
    IUser(::user::IUser const& other)
        : IUser(user_IUser_copy(other.m_handle)) {}
    IUser(::user::IUser&& other)
        : IUser(other.m_handle) {
        other.m_handle.data_ptr = nullptr;
    }
};
}
namespace taihe {
template<>
struct as_abi<::user::IUser> {
    using type = struct user_IUser_t;
};
template<>
struct as_abi<::user::weak::IUser> {
    using type = struct user_IUser_t;
};
template<>
struct as_param<::user::IUser> {
    using type = ::user::weak::IUser;
};
}
