#include "notification.proj.hpp"
#include "notification.impl.hpp"
#include "taihe/runtime.hpp"
#include "stdexcept"

using namespace taihe;
using namespace notification;

namespace {
// To be implemented.

class INotificationServiceImpl {
public:
    INotificationServiceImpl() {
        // Don't forget to implement the constructor.
    }

    void sendMessage(::user::weak::IUser a) {
        TH_THROW(std::runtime_error, "sendMessage not implemented");
    }
};

INotificationService makeNotificationService() {
    // The parameters in the make_holder function should be of the same type
    // as the parameters in the constructor of the actual implementation class.
    return make_holder<INotificationServiceImpl, INotificationService>();
}
}  // namespace

TH_EXPORT_CPP_API_makeNotificationService(makeNotificationService);
