#include "user.proj.hpp"
#include "user.impl.hpp"
#include "taihe/runtime.hpp"
#include "stdexcept"

using namespace taihe;
using namespace user;

namespace {
// To be implemented.

class IUserImpl {
public:
    IUserImpl() {
        // Don't forget to implement the constructor.
    }

    string getEmail() {
        TH_THROW(std::runtime_error, "getEmail not implemented");
    }

    void setEmail(string_view path) {
        TH_THROW(std::runtime_error, "setEmail not implemented");
    }
};

IUser makeUser(string_view path) {
    // The parameters in the make_holder function should be of the same type
    // as the parameters in the constructor of the actual implementation class.
    return make_holder<IUserImpl, IUser>();
}
}  // namespace

TH_EXPORT_CPP_API_makeUser(makeUser);
