#pragma once
#include "taihe/object.hpp"
#include "inherit.CreditCard.proj.0.hpp"
#include "inherit.CreditCard.abi.1.h"
#include "inherit.Payable.proj.1.hpp"
namespace inherit::weak {
struct CreditCard {
    static constexpr bool is_holder = false;
    struct inherit_CreditCard_t m_handle;
    explicit CreditCard(struct inherit_CreditCard_t handle) : m_handle(handle) {}
    explicit CreditCard(::taihe::data_view other)
        : CreditCard(inherit_CreditCard_dynamic(other.data_ptr)) {}
    operator ::taihe::data_view() const& {
        struct inherit_CreditCard_t ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct inherit_CreditCard_t ret_handle = inherit_CreditCard_copy(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    operator ::inherit::weak::Payable() const& {
        struct inherit_CreditCard_t ret_handle = m_handle;
        return ::inherit::weak::Payable(inherit_CreditCard_1_static(ret_handle));
    }
    operator ::inherit::Payable() const& {
        struct inherit_CreditCard_t ret_handle = inherit_CreditCard_copy(m_handle);
        return ::inherit::Payable(inherit_CreditCard_1_static(ret_handle));
    }
    struct virtual_type {
        void topUp(double topUpAmount) const&;
        double getBalance() const&;
        bool getIntlEnabled() const&;
        void setIntlEnabled(bool tag) const&;
    };
    template<typename Impl>
    struct methods_impl {
        static void topUp(struct inherit_CreditCard_t tobj, double topUpAmount);
        static double getBalance(struct inherit_CreditCard_t tobj);
        static bool getIntlEnabled(struct inherit_CreditCard_t tobj);
        static void setIntlEnabled(struct inherit_CreditCard_t tobj, bool tag);
    };
    template<typename Impl>
    static constexpr inherit_CreditCard_ftable ftbl_impl = {
        .topUp = &methods_impl<Impl>::topUp,
        .getBalance = &methods_impl<Impl>::getBalance,
        .getIntlEnabled = &methods_impl<Impl>::getIntlEnabled,
        .setIntlEnabled = &methods_impl<Impl>::setIntlEnabled,
    };
    template<typename Impl>
    static constexpr inherit_CreditCard_vtable vtbl_impl = {
        .ftbl_ptr_0 = &::inherit::weak::CreditCard::template ftbl_impl<Impl>,
        .ftbl_ptr_1 = &::inherit::weak::Payable::template ftbl_impl<Impl>,
    };
    template<typename Impl>
    static constexpr IdMapItem idmap_impl[2] = {
        {&inherit_CreditCard_i, &vtbl_impl<Impl>.ftbl_ptr_0},
        {&inherit_Payable_i, &vtbl_impl<Impl>.ftbl_ptr_1},
    };
    static constexpr void const* iid = &inherit_CreditCard_i;
    using vtable_t = inherit_CreditCard_vtable;
    explicit operator bool() const& { return m_handle.vtbl_ptr; }
    virtual_type const& operator*() const& {
        return *reinterpret_cast<virtual_type const*>(&m_handle);
    }
    virtual_type const* operator->() const& {
        return reinterpret_cast<virtual_type const*>(&m_handle);
    }
};
}
namespace inherit {
struct CreditCard : public ::inherit::weak::CreditCard {
    static constexpr bool is_holder = true;
    explicit CreditCard(struct inherit_CreditCard_t handle) : ::inherit::weak::CreditCard(handle) {}
    CreditCard& operator=(::inherit::CreditCard other) {
        ::std::swap(m_handle, other.m_handle);
        return *this;
    }
    ~CreditCard() {
        inherit_CreditCard_drop(m_handle);
    }
    explicit CreditCard(::taihe::data_holder other)
        : CreditCard(inherit_CreditCard_dynamic(other.data_ptr)) {
        other.data_ptr = nullptr;
    }
    operator ::taihe::data_view() const& {
        struct inherit_CreditCard_t ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct inherit_CreditCard_t ret_handle = inherit_CreditCard_copy(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() && {
        struct inherit_CreditCard_t ret_handle = m_handle;
        m_handle.data_ptr = nullptr;
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    CreditCard(::inherit::weak::CreditCard const& other)
        : CreditCard(inherit_CreditCard_copy(other.m_handle)) {}
    CreditCard(::inherit::CreditCard const& other)
        : CreditCard(inherit_CreditCard_copy(other.m_handle)) {}
    CreditCard(::inherit::CreditCard&& other)
        : CreditCard(other.m_handle) {
        other.m_handle.data_ptr = nullptr;
    }
    operator ::inherit::weak::Payable() const& {
        struct inherit_CreditCard_t ret_handle = m_handle;
        return ::inherit::weak::Payable(inherit_CreditCard_1_static(ret_handle));
    }
    operator ::inherit::Payable() const& {
        struct inherit_CreditCard_t ret_handle = inherit_CreditCard_copy(m_handle);
        return ::inherit::Payable(inherit_CreditCard_1_static(ret_handle));
    }
    operator ::inherit::Payable() && {
        struct inherit_CreditCard_t ret_handle = m_handle;
        m_handle.data_ptr = nullptr;
        return ::inherit::Payable(inherit_CreditCard_1_static(ret_handle));
    }
};
}
namespace taihe {
template<>
struct as_abi<::inherit::CreditCard> {
    using type = struct inherit_CreditCard_t;
};
template<>
struct as_abi<::inherit::weak::CreditCard> {
    using type = struct inherit_CreditCard_t;
};
template<>
struct as_param<::inherit::CreditCard> {
    using type = ::inherit::weak::CreditCard;
};
}
