#include "inherit.proj.hpp"
#include "inherit.impl.hpp"
#include "taihe/runtime.hpp"
#include "stdexcept"

using namespace taihe;
using namespace inherit;

namespace {
// To be implemented.

class PayableImpl {
public:
    PayableImpl() {
        // Don't forget to implement the constructor.
    }

    void pay(double amountDue) {
        TH_THROW(std::runtime_error, "pay not implemented");
    }
};

class CreditCardImpl {
public:
    CreditCardImpl() {
        // Don't forget to implement the constructor.
    }

    void topUp(double topUpAmount) {
        TH_THROW(std::runtime_error, "topUp not implemented");
    }

    double getBalance() {
        TH_THROW(std::runtime_error, "getBalance not implemented");
    }

    bool getIntlEnabled() {
        TH_THROW(std::runtime_error, "getIntlEnabled not implemented");
    }

    void setIntlEnabled(bool tag) {
        TH_THROW(std::runtime_error, "setIntlEnabled not implemented");
    }

    void pay(double amountDue) {
        TH_THROW(std::runtime_error, "pay not implemented");
    }
};

CreditCard makeCreditCard(double initAmount) {
    // The parameters in the make_holder function should be of the same type
    // as the parameters in the constructor of the actual implementation class.
    return make_holder<CreditCardImpl, CreditCard>();
}
}  // namespace

TH_EXPORT_CPP_API_makeCreditCard(makeCreditCard);
