#include "class_extends.proj.hpp"
#include "class_extends.impl.hpp"
#include "taihe/runtime.hpp"
#include "stdexcept"

using namespace taihe;
using namespace class_extends;

namespace {
// To be implemented.

class BaseContextImpl {
public:
    BaseContextImpl() {
        // Don't forget to implement the constructor.
    }

    void setName(string_view name) {
        TH_THROW(std::runtime_error, "setName not implemented");
    }

    string getName() {
        TH_THROW(std::runtime_error, "getName not implemented");
    }

    string getType(string_view ctxType) {
        TH_THROW(std::runtime_error, "getType not implemented");
    }
};

class ContextImpl {
public:
    ContextImpl() {
        // Don't forget to implement the constructor.
    }

    void setStageMode(bool stageMode) {
        TH_THROW(std::runtime_error, "setStageMode not implemented");
    }

    bool getStageMode() {
        TH_THROW(std::runtime_error, "getStageMode not implemented");
    }

    void setName(string_view name) {
        TH_THROW(std::runtime_error, "setName not implemented");
    }

    string getName() {
        TH_THROW(std::runtime_error, "getName not implemented");
    }

    string getType(string_view ctxType) {
        TH_THROW(std::runtime_error, "getType not implemented");
    }
};

class TestContextImpl {
public:
    TestContextImpl() {
        // Don't forget to implement the constructor.
    }

    void setName(string_view name) {
        TH_THROW(std::runtime_error, "setName not implemented");
    }

    string getName() {
        TH_THROW(std::runtime_error, "getName not implemented");
    }

    string getType(string_view ctxType) {
        TH_THROW(std::runtime_error, "getType not implemented");
    }
};

class ApplicationContextImpl {
public:
    ApplicationContextImpl() {
        // Don't forget to implement the constructor.
    }

    void setSupportedProcessCacheSync(bool isSupported) {
        TH_THROW(std::runtime_error, "setSupportedProcessCacheSync not implemented");
    }

    void setStageMode(bool stageMode) {
        TH_THROW(std::runtime_error, "setStageMode not implemented");
    }

    bool getStageMode() {
        TH_THROW(std::runtime_error, "getStageMode not implemented");
    }

    void setName(string_view name) {
        TH_THROW(std::runtime_error, "setName not implemented");
    }

    string getName() {
        TH_THROW(std::runtime_error, "getName not implemented");
    }

    string getType(string_view ctxType) {
        TH_THROW(std::runtime_error, "getType not implemented");
    }
};

BaseContext makeBaseContext() {
    // The parameters in the make_holder function should be of the same type
    // as the parameters in the constructor of the actual implementation class.
    return make_holder<BaseContextImpl, BaseContext>();
}

Context makeContext() {
    // The parameters in the make_holder function should be of the same type
    // as the parameters in the constructor of the actual implementation class.
    return make_holder<ContextImpl, Context>();
}

TestContext makeTestContext() {
    // The parameters in the make_holder function should be of the same type
    // as the parameters in the constructor of the actual implementation class.
    return make_holder<TestContextImpl, TestContext>();
}

ApplicationContext makeApplicationContext() {
    // The parameters in the make_holder function should be of the same type
    // as the parameters in the constructor of the actual implementation class.
    return make_holder<ApplicationContextImpl, ApplicationContext>();
}
}  // namespace

TH_EXPORT_CPP_API_makeBaseContext(makeBaseContext);
TH_EXPORT_CPP_API_makeContext(makeContext);
TH_EXPORT_CPP_API_makeTestContext(makeTestContext);
TH_EXPORT_CPP_API_makeApplicationContext(makeApplicationContext);
