#include "extends_inject.proj.hpp"
#include "extends_inject.impl.hpp"
#include "taihe/runtime.hpp"
#include "stdexcept"

using namespace taihe;
using namespace extends_inject;

namespace {
// To be implemented.

class InnerPersonImpl {
public:
    InnerPersonImpl() {
        // Don't forget to implement the constructor.
    }

    uintptr_t getPseron() {
        TH_THROW(std::runtime_error, "getPseron not implemented");
    }

    InnerPerson getInnerPerson() {
        // The parameters in the make_holder function should be of the same type
        // as the parameters in the constructor of the actual implementation class.
        return make_holder<InnerPersonImpl, InnerPerson>();
    }
};

InnerPerson makePerson() {
    // The parameters in the make_holder function should be of the same type
    // as the parameters in the constructor of the actual implementation class.
    return make_holder<InnerPersonImpl, InnerPerson>();
}
}  // namespace

TH_EXPORT_CPP_API_makePerson(makePerson);
