#pragma once
#include "taihe/object.hpp"
#include "interface.ICalculator.proj.0.hpp"
#include "interface.ICalculator.abi.1.h"
namespace interface::weak {
struct ICalculator {
    static constexpr bool is_holder = false;
    struct interface_ICalculator_t m_handle;
    explicit ICalculator(struct interface_ICalculator_t handle) : m_handle(handle) {}
    explicit ICalculator(::taihe::data_view other)
        : ICalculator(interface_ICalculator_dynamic(other.data_ptr)) {}
    operator ::taihe::data_view() const& {
        struct interface_ICalculator_t ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct interface_ICalculator_t ret_handle = interface_ICalculator_copy(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    struct virtual_type {
        int32_t add(int32_t a, int32_t b) const&;
        int32_t sub(int32_t a, int32_t b) const&;
        int32_t getLastResult() const&;
        void reset() const&;
    };
    template<typename Impl>
    struct methods_impl {
        static int32_t add(struct interface_ICalculator_t tobj, int32_t a, int32_t b);
        static int32_t sub(struct interface_ICalculator_t tobj, int32_t a, int32_t b);
        static int32_t getLastResult(struct interface_ICalculator_t tobj);
        static void reset(struct interface_ICalculator_t tobj);
    };
    template<typename Impl>
    static constexpr interface_ICalculator_ftable ftbl_impl = {
        .add = &methods_impl<Impl>::add,
        .sub = &methods_impl<Impl>::sub,
        .getLastResult = &methods_impl<Impl>::getLastResult,
        .reset = &methods_impl<Impl>::reset,
    };
    template<typename Impl>
    static constexpr interface_ICalculator_vtable vtbl_impl = {
        .ftbl_ptr_0 = &::interface::weak::ICalculator::template ftbl_impl<Impl>,
    };
    template<typename Impl>
    static constexpr IdMapItem idmap_impl[1] = {
        {&interface_ICalculator_i, &vtbl_impl<Impl>.ftbl_ptr_0},
    };
    static constexpr void const* iid = &interface_ICalculator_i;
    using vtable_t = interface_ICalculator_vtable;
    explicit operator bool() const& { return m_handle.vtbl_ptr; }
    virtual_type const& operator*() const& {
        return *reinterpret_cast<virtual_type const*>(&m_handle);
    }
    virtual_type const* operator->() const& {
        return reinterpret_cast<virtual_type const*>(&m_handle);
    }
};
}
namespace interface {
struct ICalculator : public ::interface::weak::ICalculator {
    static constexpr bool is_holder = true;
    explicit ICalculator(struct interface_ICalculator_t handle) : ::interface::weak::ICalculator(handle) {}
    ICalculator& operator=(::interface::ICalculator other) {
        ::std::swap(m_handle, other.m_handle);
        return *this;
    }
    ~ICalculator() {
        interface_ICalculator_drop(m_handle);
    }
    explicit ICalculator(::taihe::data_holder other)
        : ICalculator(interface_ICalculator_dynamic(other.data_ptr)) {
        other.data_ptr = nullptr;
    }
    operator ::taihe::data_view() const& {
        struct interface_ICalculator_t ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct interface_ICalculator_t ret_handle = interface_ICalculator_copy(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() && {
        struct interface_ICalculator_t ret_handle = m_handle;
        m_handle.data_ptr = nullptr;
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    ICalculator(::interface::weak::ICalculator const& other)
        : ICalculator(interface_ICalculator_copy(other.m_handle)) {}
    ICalculator(::interface::ICalculator const& other)
        : ICalculator(interface_ICalculator_copy(other.m_handle)) {}
    ICalculator(::interface::ICalculator&& other)
        : ICalculator(other.m_handle) {
        other.m_handle.data_ptr = nullptr;
    }
};
}
namespace taihe {
template<>
struct as_abi<::interface::ICalculator> {
    using type = struct interface_ICalculator_t;
};
template<>
struct as_abi<::interface::weak::ICalculator> {
    using type = struct interface_ICalculator_t;
};
template<>
struct as_param<::interface::ICalculator> {
    using type = ::interface::weak::ICalculator;
};
}
