#include "interface.proj.hpp"
#include "interface.impl.hpp"
#include "taihe/runtime.hpp"
#include "stdexcept"

using namespace taihe;
using namespace interface;

namespace {
// To be implemented.

class ICalculatorImpl {
public:
    ICalculatorImpl() {
        // Don't forget to implement the constructor.
    }

    int32_t add(int32_t a, int32_t b) {
        TH_THROW(std::runtime_error, "add not implemented");
    }

    int32_t sub(int32_t a, int32_t b) {
        TH_THROW(std::runtime_error, "sub not implemented");
    }

    int32_t getLastResult() {
        TH_THROW(std::runtime_error, "getLastResult not implemented");
    }

    void reset() {
        TH_THROW(std::runtime_error, "reset not implemented");
    }
};

ICalculator makeCalculator(int32_t init) {
    // The parameters in the make_holder function should be of the same type
    // as the parameters in the constructor of the actual implementation class.
    return make_holder<ICalculatorImpl, ICalculator>();
}

void restartCalculator(weak::ICalculator a) {
    TH_THROW(std::runtime_error, "restartCalculator not implemented");
}
}  // namespace

TH_EXPORT_CPP_API_makeCalculator(makeCalculator);
TH_EXPORT_CPP_API_restartCalculator(restartCalculator);
