#include "ns_test.foo.ani.hpp"
#include "ns_test.baz.ani.hpp"
#include "ns_test.foo.bar.ani.hpp"
#include "new_ns.ani.hpp"
#include "new_ns.my_ns.ani.hpp"
ANI_EXPORT ani_status ANI_Constructor(ani_vm *vm, uint32_t *result) {
    ani_env *env;
    if (ANI_OK != vm->GetEnv(ANI_VERSION_1, &env)) {
        return ANI_ERROR;
    }
    if (ANI_OK != ns_test::foo::ANIRegister(env)) {
        std::cerr << "ns_test::foo" << std::endl;
        return ANI_ERROR;
    }
    if (ANI_OK != ns_test::baz::ANIRegister(env)) {
        std::cerr << "ns_test::baz" << std::endl;
        return ANI_ERROR;
    }
    if (ANI_OK != ns_test::foo::bar::ANIRegister(env)) {
        std::cerr << "ns_test::foo::bar" << std::endl;
        return ANI_ERROR;
    }
    if (ANI_OK != new_ns::ANIRegister(env)) {
        std::cerr << "new_ns" << std::endl;
        return ANI_ERROR;
    }
    if (ANI_OK != new_ns::my_ns::ANIRegister(env)) {
        std::cerr << "new_ns::my_ns" << std::endl;
        return ANI_ERROR;
    }
    *result = ANI_VERSION_1;
    return ANI_OK;
}
