#include "ns_test.foo.proj.hpp"
#include "ns_test.foo.impl.hpp"
#include "taihe/runtime.hpp"
#include "stdexcept"

using namespace taihe;
using namespace ns_test::foo;

namespace {
// To be implemented.

class windowImpl {
public:
    windowImpl() {
        // Don't forget to implement the constructor.
    }

    int32_t getheight() {
        TH_THROW(std::runtime_error, "getheight not implemented");
    }

    void setheight(int32_t b) {
        TH_THROW(std::runtime_error, "setheight not implemented");
    }
};

window get_interface(int32_t v) {
    // The parameters in the make_holder function should be of the same type
    // as the parameters in the constructor of the actual implementation class.
    return make_holder<windowImpl, window>();
}

void check_interface(weak::window a) {
    TH_THROW(std::runtime_error, "check_interface not implemented");
}
}  // namespace

TH_EXPORT_CPP_API_get_interface(get_interface);
TH_EXPORT_CPP_API_check_interface(check_interface);
