#pragma once
#include "taihe/object.hpp"
#include "override.UIAbility.proj.0.hpp"
#include "override.UIAbility.abi.1.h"
namespace override::weak {
struct UIAbility {
    static constexpr bool is_holder = false;
    struct override_UIAbility_t m_handle;
    explicit UIAbility(struct override_UIAbility_t handle) : m_handle(handle) {}
    explicit UIAbility(::taihe::data_view other)
        : UIAbility(override_UIAbility_dynamic(other.data_ptr)) {}
    operator ::taihe::data_view() const& {
        struct override_UIAbility_t ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct override_UIAbility_t ret_handle = override_UIAbility_copy(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    struct virtual_type {
        void onForeground() const&;
        void onBackground() const&;
    };
    template<typename Impl>
    struct methods_impl {
        static void onForeground(struct override_UIAbility_t tobj);
        static void onBackground(struct override_UIAbility_t tobj);
    };
    template<typename Impl>
    static constexpr override_UIAbility_ftable ftbl_impl = {
        .onForeground = &methods_impl<Impl>::onForeground,
        .onBackground = &methods_impl<Impl>::onBackground,
    };
    template<typename Impl>
    static constexpr override_UIAbility_vtable vtbl_impl = {
        .ftbl_ptr_0 = &::override::weak::UIAbility::template ftbl_impl<Impl>,
    };
    template<typename Impl>
    static constexpr IdMapItem idmap_impl[1] = {
        {&override_UIAbility_i, &vtbl_impl<Impl>.ftbl_ptr_0},
    };
    static constexpr void const* iid = &override_UIAbility_i;
    using vtable_t = override_UIAbility_vtable;
    explicit operator bool() const& { return m_handle.vtbl_ptr; }
    virtual_type const& operator*() const& {
        return *reinterpret_cast<virtual_type const*>(&m_handle);
    }
    virtual_type const* operator->() const& {
        return reinterpret_cast<virtual_type const*>(&m_handle);
    }
};
}
namespace override {
struct UIAbility : public ::override::weak::UIAbility {
    static constexpr bool is_holder = true;
    explicit UIAbility(struct override_UIAbility_t handle) : ::override::weak::UIAbility(handle) {}
    UIAbility& operator=(::override::UIAbility other) {
        ::std::swap(m_handle, other.m_handle);
        return *this;
    }
    ~UIAbility() {
        override_UIAbility_drop(m_handle);
    }
    explicit UIAbility(::taihe::data_holder other)
        : UIAbility(override_UIAbility_dynamic(other.data_ptr)) {
        other.data_ptr = nullptr;
    }
    operator ::taihe::data_view() const& {
        struct override_UIAbility_t ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct override_UIAbility_t ret_handle = override_UIAbility_copy(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() && {
        struct override_UIAbility_t ret_handle = m_handle;
        m_handle.data_ptr = nullptr;
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    UIAbility(::override::weak::UIAbility const& other)
        : UIAbility(override_UIAbility_copy(other.m_handle)) {}
    UIAbility(::override::UIAbility const& other)
        : UIAbility(override_UIAbility_copy(other.m_handle)) {}
    UIAbility(::override::UIAbility&& other)
        : UIAbility(other.m_handle) {
        other.m_handle.data_ptr = nullptr;
    }
};
}
namespace taihe {
template<>
struct as_abi<::override::UIAbility> {
    using type = struct override_UIAbility_t;
};
template<>
struct as_abi<::override::weak::UIAbility> {
    using type = struct override_UIAbility_t;
};
template<>
struct as_param<::override::UIAbility> {
    using type = ::override::weak::UIAbility;
};
}
