#include "override.proj.hpp"
#include "override.impl.hpp"
#include "taihe/runtime.hpp"
#include "stdexcept"

using namespace taihe;
using namespace override;

namespace {
// To be implemented.

class UIAbilityImpl {
public:
    UIAbilityImpl() {
        // Don't forget to implement the constructor.
    }

    void onForeground() {
        TH_THROW(std::runtime_error, "onForeground not implemented");
    }

    void onBackground() {
        TH_THROW(std::runtime_error, "onBackground not implemented");
    }
};

UIAbility getUIAbility() {
    // The parameters in the make_holder function should be of the same type
    // as the parameters in the constructor of the actual implementation class.
    return make_holder<UIAbilityImpl, UIAbility>();
}

void useUIAbility(weak::UIAbility a) {
    TH_THROW(std::runtime_error, "useUIAbility not implemented");
}
}  // namespace

TH_EXPORT_CPP_API_getUIAbility(getUIAbility);
TH_EXPORT_CPP_API_useUIAbility(useUIAbility);
