#pragma once
#include "taihe/common.hpp"
#include "hms.core.map.map_inner.icons_type.proj.0.hpp"
#include "hms.core.map.map_inner.icons_type.abi.1.h"
#include "taihe/string.hpp"
#include "hms.core.map.map_inner.Resource.proj.2.hpp"
namespace hms::core::map::map_inner {
struct icons_type {
    enum class tag_t : int {
        type_string,
        type_Resource,
        type_Image,
    };
    union storage_t {
        storage_t() {}
        ~storage_t() {}
        ::taihe::string type_string;
        ::hms::core::map::map_inner::Resource type_Resource;
        uintptr_t type_Image;
    };
    icons_type(icons_type const& other) : m_tag(other.m_tag) {
        switch (m_tag) {
        case tag_t::type_string:
            new (&m_data.type_string) decltype(m_data.type_string)(other.m_data.type_string);
            break;
        case tag_t::type_Resource:
            new (&m_data.type_Resource) decltype(m_data.type_Resource)(other.m_data.type_Resource);
            break;
        case tag_t::type_Image:
            new (&m_data.type_Image) decltype(m_data.type_Image)(other.m_data.type_Image);
            break;
        default:
            break;
        }
    }
    icons_type(icons_type&& other) : m_tag(other.m_tag) {
        switch (m_tag) {
        case tag_t::type_string:
            new (&m_data.type_string) decltype(m_data.type_string)(::std::move(other.m_data.type_string));
            break;
        case tag_t::type_Resource:
            new (&m_data.type_Resource) decltype(m_data.type_Resource)(::std::move(other.m_data.type_Resource));
            break;
        case tag_t::type_Image:
            new (&m_data.type_Image) decltype(m_data.type_Image)(::std::move(other.m_data.type_Image));
            break;
        default:
            break;
        }
    }
    icons_type& operator=(icons_type const& other) {
        if (this != &other) {
            ::std::destroy_at(this);
            new (this) icons_type(other);
        }
        return *this;
    }
    icons_type& operator=(icons_type&& other) {
        if (this != &other) {
            ::std::destroy_at(this);
            new (this) icons_type(::std::move(other));
        }
        return *this;
    }
    ~icons_type() {
        switch (m_tag) {
        case tag_t::type_string:
            ::std::destroy_at(&m_data.type_string);
            break;
        case tag_t::type_Resource:
            ::std::destroy_at(&m_data.type_Resource);
            break;
        case tag_t::type_Image:
            ::std::destroy_at(&m_data.type_Image);
            break;
        default:
            break;
        }
    }
    template<typename... Args>
    icons_type(::taihe::static_tag_t<tag_t::type_string>, Args&&... args) : m_tag(tag_t::type_string) {
        new (&m_data.type_string) decltype(m_data.type_string)(::std::forward<Args>(args)...);
    }
    template<typename... Args>
    icons_type(::taihe::static_tag_t<tag_t::type_Resource>, Args&&... args) : m_tag(tag_t::type_Resource) {
        new (&m_data.type_Resource) decltype(m_data.type_Resource)(::std::forward<Args>(args)...);
    }
    template<typename... Args>
    icons_type(::taihe::static_tag_t<tag_t::type_Image>, Args&&... args) : m_tag(tag_t::type_Image) {
        new (&m_data.type_Image) decltype(m_data.type_Image)(::std::forward<Args>(args)...);
    }
    template<tag_t tag, typename... Args>
    static icons_type make(Args&&... args) {
        return icons_type(::taihe::static_tag<tag>, ::std::forward<Args>(args)...);
    }
    template<tag_t tag, typename... Args>
    icons_type const& emplace(Args&&... args) {
        ::std::destroy_at(this);
        new (this) icons_type(::taihe::static_tag<tag>, ::std::forward<Args>(args)...);
        return *this;
    }
    template<tag_t tag>
    auto& get_ref() {
        if constexpr (tag == tag_t::type_string) {
            return m_data.type_string;
        }
        if constexpr (tag == tag_t::type_Resource) {
            return m_data.type_Resource;
        }
        if constexpr (tag == tag_t::type_Image) {
            return m_data.type_Image;
        }
    }
    template<tag_t tag>
    auto* get_ptr() {
        return m_tag == tag ? &get_ref<tag>() : nullptr;
    }
    template<tag_t tag>
    auto const& get_ref() const {
        if constexpr (tag == tag_t::type_string) {
            return m_data.type_string;
        }
        if constexpr (tag == tag_t::type_Resource) {
            return m_data.type_Resource;
        }
        if constexpr (tag == tag_t::type_Image) {
            return m_data.type_Image;
        }
    }
    template<tag_t tag>
    auto const* get_ptr() const {
        return m_tag == tag ? &get_ref<tag>() : nullptr;
    }
    template<tag_t tag>
    bool holds() const {
        return m_tag == tag;
    }
    tag_t get_tag() const {
        return m_tag;
    }
    template<typename Visitor>
    auto accept_template(Visitor&& visitor) {
        switch (m_tag) {
        case tag_t::type_string:
            return visitor(::taihe::static_tag<tag_t::type_string>, m_data.type_string);
        case tag_t::type_Resource:
            return visitor(::taihe::static_tag<tag_t::type_Resource>, m_data.type_Resource);
        case tag_t::type_Image:
            return visitor(::taihe::static_tag<tag_t::type_Image>, m_data.type_Image);
        }
    }
    template<typename Visitor>
    auto accept_template(Visitor&& visitor) const {
        switch (m_tag) {
        case tag_t::type_string:
            return visitor(::taihe::static_tag<tag_t::type_string>, m_data.type_string);
        case tag_t::type_Resource:
            return visitor(::taihe::static_tag<tag_t::type_Resource>, m_data.type_Resource);
        case tag_t::type_Image:
            return visitor(::taihe::static_tag<tag_t::type_Image>, m_data.type_Image);
        }
    }
    template<typename... Args>
    static icons_type make_type_string(Args&&... args) {
        return make<tag_t::type_string>(::std::forward<Args>(args)...);
    }
    template<typename... Args>
    icons_type const& emplace_type_string(Args&&... args) {
        return emplace<tag_t::type_string>(::std::forward<Args>(args)...);
    }
    bool holds_type_string() const {
        return holds<tag_t::type_string>();
    }
    auto* get_type_string_ptr() {
        return get_ptr<tag_t::type_string>();
    }
    auto const* get_type_string_ptr() const {
        return get_ptr<tag_t::type_string>();
    }
    auto& get_type_string_ref() {
        return get_ref<tag_t::type_string>();
    }
    auto const& get_type_string_ref() const {
        return get_ref<tag_t::type_string>();
    }
    template<typename... Args>
    static icons_type make_type_Resource(Args&&... args) {
        return make<tag_t::type_Resource>(::std::forward<Args>(args)...);
    }
    template<typename... Args>
    icons_type const& emplace_type_Resource(Args&&... args) {
        return emplace<tag_t::type_Resource>(::std::forward<Args>(args)...);
    }
    bool holds_type_Resource() const {
        return holds<tag_t::type_Resource>();
    }
    auto* get_type_Resource_ptr() {
        return get_ptr<tag_t::type_Resource>();
    }
    auto const* get_type_Resource_ptr() const {
        return get_ptr<tag_t::type_Resource>();
    }
    auto& get_type_Resource_ref() {
        return get_ref<tag_t::type_Resource>();
    }
    auto const& get_type_Resource_ref() const {
        return get_ref<tag_t::type_Resource>();
    }
    template<typename... Args>
    static icons_type make_type_Image(Args&&... args) {
        return make<tag_t::type_Image>(::std::forward<Args>(args)...);
    }
    template<typename... Args>
    icons_type const& emplace_type_Image(Args&&... args) {
        return emplace<tag_t::type_Image>(::std::forward<Args>(args)...);
    }
    bool holds_type_Image() const {
        return holds<tag_t::type_Image>();
    }
    auto* get_type_Image_ptr() {
        return get_ptr<tag_t::type_Image>();
    }
    auto const* get_type_Image_ptr() const {
        return get_ptr<tag_t::type_Image>();
    }
    auto& get_type_Image_ref() {
        return get_ref<tag_t::type_Image>();
    }
    auto const& get_type_Image_ref() const {
        return get_ref<tag_t::type_Image>();
    }
    template<typename Visitor>
    auto accept(Visitor&& visitor) {
        switch (m_tag) {
        case tag_t::type_string:
            return visitor.type_string(m_data.type_string);
        case tag_t::type_Resource:
            return visitor.type_Resource(m_data.type_Resource);
        case tag_t::type_Image:
            return visitor.type_Image(m_data.type_Image);
        }
    }
    template<typename Visitor>
    auto accept(Visitor&& visitor) const {
        switch (m_tag) {
        case tag_t::type_string:
            return visitor.type_string(m_data.type_string);
        case tag_t::type_Resource:
            return visitor.type_Resource(m_data.type_Resource);
        case tag_t::type_Image:
            return visitor.type_Image(m_data.type_Image);
        }
    }
private:
    tag_t m_tag;
    storage_t m_data;
};
}
namespace taihe {
inline bool same_impl(adl_helper_t, ::hms::core::map::map_inner::icons_type const& lhs, ::hms::core::map::map_inner::icons_type const& rhs) {
    return false || (lhs.holds_type_string() && rhs.holds_type_string() && same(lhs.get_type_string_ref(), rhs.get_type_string_ref())) || (lhs.holds_type_Resource() && rhs.holds_type_Resource() && same(lhs.get_type_Resource_ref(), rhs.get_type_Resource_ref())) || (lhs.holds_type_Image() && rhs.holds_type_Image() && same(lhs.get_type_Image_ref(), rhs.get_type_Image_ref()));
}
}
namespace taihe {
inline auto hash_impl(adl_helper_t, ::hms::core::map::map_inner::icons_type const& val) -> ::std::size_t {
    switch (val.get_tag()) {
        ::std::size_t seed;
    case ::hms::core::map::map_inner::icons_type::tag_t::type_string:
        seed = (::std::size_t)::hms::core::map::map_inner::icons_type::tag_t::type_string;
        return seed ^ (0x9e3779b9 + (seed << 6) + (seed >> 2) + hash(val.get_type_string_ref()));
    case ::hms::core::map::map_inner::icons_type::tag_t::type_Resource:
        seed = (::std::size_t)::hms::core::map::map_inner::icons_type::tag_t::type_Resource;
        return seed ^ (0x9e3779b9 + (seed << 6) + (seed >> 2) + hash(val.get_type_Resource_ref()));
    case ::hms::core::map::map_inner::icons_type::tag_t::type_Image:
        seed = (::std::size_t)::hms::core::map::map_inner::icons_type::tag_t::type_Image;
        return seed ^ (0x9e3779b9 + (seed << 6) + (seed >> 2) + hash(val.get_type_Image_ref()));
    }
}
}
namespace taihe {
template<>
struct as_abi<::hms::core::map::map_inner::icons_type> {
    using type = struct hms_core_map_map_inner_icons_type_t32;
};
template<>
struct as_abi<::hms::core::map::map_inner::icons_type const&> {
    using type = struct hms_core_map_map_inner_icons_type_t32 const*;
};
template<>
struct as_param<::hms::core::map::map_inner::icons_type> {
    using type = ::hms::core::map::map_inner::icons_type const&;
};
}
