#include "hms.core.map.map_inner.proj.hpp"
#include "hms.core.map.map_inner.impl.hpp"
#include "taihe/runtime.hpp"
#include "stdexcept"

using namespace taihe;
using namespace hms::core::map::map_inner;

namespace {
// To be implemented.

class ResourceImpl {
public:
    ResourceImpl() {
        // Don't forget to implement the constructor.
    }

    void foo(int32_t a) {
        TH_THROW(std::runtime_error, "foo not implemented");
    }
};

class map_innerImpl {
public:
    map_innerImpl() {
        // Don't forget to implement the constructor.
    }

    string getId() {
        TH_THROW(std::runtime_error, "getId not implemented");
    }

    int32_t getZIndex() {
        TH_THROW(std::runtime_error, "getZIndex not implemented");
    }

    int32_t getMaxZoom() {
        TH_THROW(std::runtime_error, "getMaxZoom not implemented");
    }

    int32_t getMinZoom() {
        TH_THROW(std::runtime_error, "getMinZoom not implemented");
    }

    int32_t setIcons_sync(array_view<icons_type> icons) {
        TH_THROW(std::runtime_error, "setIcons_sync not implemented");
    }

    void setPositions(array_view<array<Resource>> positions) {
        TH_THROW(std::runtime_error, "setPositions not implemented");
    }
};

Resource createResource() {
    // The parameters in the make_holder function should be of the same type
    // as the parameters in the constructor of the actual implementation class.
    return make_holder<ResourceImpl, Resource>();
}

map_inner make_map_inner() {
    // The parameters in the make_holder function should be of the same type
    // as the parameters in the constructor of the actual implementation class.
    return make_holder<map_innerImpl, map_inner>();
}
}  // namespace

TH_EXPORT_CPP_API_createResource(createResource);
TH_EXPORT_CPP_API_make_map_inner(make_map_inner);
